unit Couleurs;
{*********************************************************}
{*                                                       *}
{*      Gnre le dgrad de couleur pour voir les       *}
{*                  contraintes                          *}
{*********************************************************}
interface

uses Graphics;

var

  Degrade : array[0..60] of TColor;

implementation

var
  I, J, Faible_Debut, Moyen_Debut, Fort_Debut,
  Faible_Fin, Moyen_Fin, Fort_Fin: smallInt;
  Debut, Fin : longint;

begin
  Degrade[0]:=8380736;   {violet}
  Degrade[12]:=clBlue; {bleu}
  Degrade[24]:=clGreen;    {vert}
  Degrade[36]:=clYellow;    {jaune}
  Degrade[48]:=33023;    {orange}
  Degrade[60]:=clRed;      {rouge}
  for I:=0 to 4 do begin
    Debut:=Degrade[I*12]; Fin:=Degrade[I*12+12];
    Faible_Debut:=Debut mod 256;
    Faible_Fin:=Fin mod 256;
    Fort_Debut:=(Debut div 65536) mod 256;
    Fort_Fin:=(Fin div 65536) mod 256;
    Moyen_Debut:=(Debut div 256) mod 256;
    Moyen_Fin:=(Fin div 256) mod 256;
    for J:=1 to 11 do begin
      Degrade[I*12+J]:=round((Faible_Debut*(12-I)+Faible_Fin*I)/12)+
                       round((Moyen_Debut*(12-I)+Moyen_Fin*I)/12)*256+
                       round((Fort_Debut*(12-I)+Fort_Fin*I)/12)*65536;
    end;
  end;
  Degrade[0]:=clBlack;
end.

