{$N-}
unit Decline;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Mask, ExtCtrls, Dialogs, uconvergence, SysUtils;

type
  TDeclinaisonDefaut = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    Label2: TLabel;
    MaskEdit1: TMaskEdit;
    Label3: TLabel;
    Edit2: TEdit;
    Label6: TLabel;
    GroupBox2: TGroupBox;
    Label9: TLabel;
    Edit3: TEdit;
    Label10: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label4: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button3Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Label4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Tournant : boolean;
  end;

var
  DeclinaisonDefaut: TDeclinaisonDefaut;

implementation

uses FicheTpo, ShellApi;

{$R *.DFM}

procedure TDeclinaisonDefaut.OKBtnClick(Sender: TObject);
var
  Ptte_Chaine : String;
  Valeur : reel;
begin
  try
    try
      Valeur:=StrToFloat(Edit1.Text);
    except
      MessageDlg('La dclinaison doit tre numrique.',mtWarning,[mbOk],0);
      Edit1.SetFocus;
      raise;
    end;
    try
      Valeur:=StrToFloat(Edit2.Text);
    except
      MessageDlg('La variation de la dclinaison doit tre numrique.',mtConfirmation,[mbOk],0);
      Edit2.SetFocus;
      raise;
    end;
    try
      Valeur:=StrToFloat(Edit3.Text);
    except
      MessageDlg('La dclinaison doit tre numrique.',mtWarning,[mbOk],0);
      Edit3.SetFocus;
      raise;
    end;
    Ptte_Chaine:=MaskEdit1.Text;
    if (Ptte_Chaine[2]=' ') or (Ptte_Chaine[5]=' ') or (Ptte_Chaine[8]=' ')
    then begin
      MessageDlg('La date n''est pas valable.',mtConfirmation,[mbOk],0);
      MaskEdit1.SetFocus;
      Abort;
    end;
  except
    modalResult:=mrNone;
  end;    
end;

procedure TDeclinaisonDefaut.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) and (Key<>'.') and (Key<>'-')
      then Key := #0;
end;

procedure TDeclinaisonDefaut.Button3Click(Sender: TObject);
begin
  Convergence:=TConvergence.Create(self);
  if Convergence.ShowModal=mrOk then
    Edit3.Text:=FloatTostrF(Convergence.A,ffGeneral,8,3);
  Convergence.Free;
end;

procedure TDeclinaisonDefaut.Edit3Change(Sender: TObject);
begin
  Tournant:=true;
end;

procedure TDeclinaisonDefaut.Label4Click(Sender: TObject);
begin
  ShellExecute(0, nil,'http://www.ngdc.noaa.gov/seg/geomag/jsp/Declination.jsp' , nil, nil,SW_SHOWNORMAL);
end;

end.
