{$N-}
unit Ecran1;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Prefecra;

type
  TForm3 = class(TForm)
    ListBox1: TListBox;
    Haut: TBitBtn;
    Bas: TBitBtn;
    Label18: TLabel;
    Taille: TEdit;
    Group_Unite: TGroupBox;
    Label19: TLabel;
    Taille_Unite: TEdit;
    Unite: TComboBox;
    Group_Colonne: TGroupBox;
    Colonne: TCheckBox;
    Label1: TLabel;
    Separateur: TEdit;
    Group_Supplement: TGroupBox;
    Manuel: TCheckBox;
    Label2: TLabel;
    Taille_Manuel: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Taille_LongueurKeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HautClick(Sender: TObject);
    procedure BasClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
    Une_Preference, En_Cours : TPreference_Ecran;
    Actuel : integer;
    procedure Enregistrer;
    procedure Remplir;
    procedure Precedent(var Ancienne : TPreference_Ecran);
    function LaTaille : integer;
    function LaTaille_Unite : integer;
    function LaTailleDef : integer;
  end;

var
  Form3: TForm3;

implementation

uses FicheTpo;

{$R *.DFM}

function TForm3.LaTaille : integer;
begin
  LaTaille:=StrToIntE(self.Taille.Text);
end;

function TForm3.LaTaille_Unite : integer;
begin
  LaTaille_Unite:=StrToIntE(self.Taille_Unite.Text);
end;

function TForm3.LaTailleDef : integer;
begin
  LaTailleDef:=StrToIntE(self.Taille_Manuel.Text);
end;

procedure TForm3.Precedent(var Ancienne : TPreference_Ecran);
begin
  Une_Preference:=Ancienne;
  En_Cours:=TPreference_Ecran.Create;
  with En_Cours do begin
    Longueur:=Une_Preference.Longueur;
    Azimuth:=Une_Preference.Azimuth;
    Pente:=Une_Preference.Pente;
    Largeur:=Une_Preference.Largeur;
    Hauteur:=Une_Preference.Hauteur;
    Schema:=Une_Preference.Schema;
    Commentaire:=Une_Preference.Commentaire;
    Point:=Une_Preference.Point;
    Correction_Horizontale:=Une_Preference.Correction_Horizontale;
    Correction_Dlt:=Une_Preference.Correction_Dlt;

    ListBox1.Items[Point.Ordre]:='Point';
    ListBox1.Items[Longueur.Ordre]:='Longueur';
    ListBox1.Items[Azimuth.Ordre]:='Azimut';
    ListBox1.Items[Pente.Ordre]:='Pente';
    ListBox1.Items[Largeur.Ordre]:='Largeur';
    ListBox1.Items[Hauteur.Ordre]:='Hauteur';
    ListBox1.Items[Schema.Ordre]:='Croquis';
    ListBox1.Items[Commentaire.Ordre]:='Commentaires';
    ListBox1.Items[Correction_Horizontale.Ordre]:='Dv. horizontal';
    ListBox1.Items[Correction_Dlt.Ordre]:='Dveloppement';
  end;
  Remplir;
end;

procedure TForm3.Remplir;
begin
  Actuel:=-1;
  ListBox1.ItemIndex:=0;
  ListBox1Click(self);
end;


procedure TForm3.Enregistrer;
var
  Ptt_Text : string;
  I : integer;
begin
  if Actuel>-1 then begin
    Ptt_Text:=ListBox1.Items[Actuel];
    if Ptt_Text='Longueur' then with En_Cours.Longueur do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      Unite_Defaut:=Unite.Text;
    end;
    if Ptt_Text='Azimut' then with En_Cours.Azimuth do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      Unite_Defaut:=Unite.Text;
    end;
    if Ptt_Text='Pente' then with En_Cours.Pente do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      Unite_Defaut:=Unite.Text;
    end;
    if Ptt_Text='Largeur' then with En_Cours.Largeur do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      Unite_defaut:=Unite.Text;
      Separateur:=self.Separateur.Text[1];
      Deux_Colonne:=Colonne.Checked;
    end;
    if Ptt_Text='Hauteur' then with En_Cours.Hauteur do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      Unite_defaut:=Unite.Text;
      Separateur:=self.Separateur.Text[1];
      Deux_Colonne:=Colonne.Checked;
    end;
    if Ptt_Text='Croquis' then with En_Cours.Schema do Taille:=LaTaille;
    if Ptt_Text='Commentaires' then with En_Cours.Commentaire do Taille:=LaTaille;
    if Ptt_Text='Point topo' then with En_Cours.Point do Taille:=LaTaille;
    if Ptt_Text='Dv. horizontal' then with En_Cours.Correction_Horizontale do begin
      Taille:=LaTaille;
      TailleDef:=LaTailleDef;
      Existe:=Manuel.Checked;
    end;
    if Ptt_Text='Dveloppement' then with En_Cours.Correction_Dlt do begin
      Taille:=LaTaille;
      TailleDef:=LaTailleDef;
      Existe:=Manuel.Checked;
    end;
  end;
  with Une_Preference do begin
    Longueur:=En_Cours.Longueur;
    Azimuth:=En_Cours.Azimuth;
    Pente:=En_Cours.Pente;
    Largeur:=En_Cours.Largeur;
    Hauteur:=En_Cours.Hauteur;
    Schema:=En_Cours.Schema;
    Commentaire:=En_Cours.Commentaire;
    Point:=En_Cours.Point;
    Correction_Horizontale:=En_Cours.Correction_Horizontale;
    Correction_Dlt:=En_Cours.Correction_Dlt;
  end;
  for I:=0 to ListBox1.Items.Count-1 do begin
    if ListBox1.Items[I]='Longueur' then Une_Preference.Longueur.Ordre:=I;
    if ListBox1.Items[I]='Azimut' then Une_Preference.Azimuth.Ordre:=I;
    if ListBox1.Items[I]='Pente' then Une_Preference.Pente.Ordre:=I;
    if ListBox1.Items[I]='Largeur' then Une_Preference.Largeur.Ordre:=I;
    if ListBox1.Items[I]='Hauteur' then Une_Preference.Hauteur.Ordre:=I;
    if ListBox1.Items[I]='Croquis' then Une_Preference.Schema.Ordre:=I;
    if ListBox1.Items[I]='Commentaires' then Une_Preference.Commentaire.Ordre:=I;
    if ListBox1.Items[I]='Dv. horizontal' then Une_Preference.Correction_Horizontale.Ordre:=I;
    if ListBox1.Items[I]='Dveloppement' then Une_Preference.Correction_Dlt.Ordre:=I;
  end;
  Une_Preference.Compile;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  PixelsPerInch:=Screen.PixelsPerInch;
end;

procedure TForm3.Taille_LongueurKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) then Key := #0;
end;

procedure TForm3.ListBox1Click(Sender: TObject);
var
  Ptt_Text : string;
begin
  if Actuel>-1 then begin
    Ptt_Text:=ListBox1.Items[Actuel];
    if Ptt_Text='Longueur' then with En_Cours.Longueur do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      Ptt_Text:=UpperCase(Unite.Text);
      if UpperCase(Unite.Text)=UpperCase(tuDistance[cm]) then Unite_Defaut:=tuDistance[cm]
      else if UpperCase(Unite.Text)=UpperCase(tuDistance[m]) then Unite_Defaut:=tuDistance[m];
    end;
    if Ptt_Text='Azimut' then with En_Cours.Azimuth do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      if UpperCase(Unite.Text)=UpperCase(tuAngle[deg]) then Unite_Defaut:=tuAngle[deg]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[gr]) then Unite_Defaut:=tuAngle[gr]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[ndeg]) then Unite_Defaut:=tuAngle[ndeg]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[ngr]) then Unite_Defaut:=tuAngle[ngr];
    end;
    if Ptt_Text='Pente' then with En_Cours.Pente do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      if UpperCase(Unite.Text)=UpperCase(tuAngle[deg]) then Unite_Defaut:=tuAngle[deg]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[gr]) then Unite_Defaut:=tuAngle[gr]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[mp]) then Unite_Defaut:=tuAngle[mp]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[cmp]) then Unite_Defaut:=tuAngle[cmp]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[vdeg]) then Unite_Defaut:=tuAngle[vdeg]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[ndeg]) then Unite_Defaut:=tuAngle[ndeg]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[ngr]) then Unite_Defaut:=tuAngle[ngr]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[nmp]) then Unite_Defaut:=tuAngle[nmp]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[ncmp]) then Unite_Defaut:=tuAngle[ncmp]
      else if UpperCase(Unite.Text)=UpperCase(tuAngle[nvdeg]) then Unite_Defaut:=tuAngle[nvdeg];
    end;
    if Ptt_Text='Largeur' then with En_Cours.Largeur do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      if UpperCase(Unite.Text)=UpperCase(tuDistance[cm]) then Unite_Defaut:=tuDistance[cm]
      else if UpperCase(Unite.Text)=UpperCase(tuDistance[m]) then Unite_Defaut:=tuDistance[m];
      Separateur:=self.Separateur.Text[1];
      Deux_Colonne:=Colonne.Checked;
    end;
    if Ptt_Text='Hauteur' then with En_Cours.Hauteur do begin
      Taille:=LaTaille;
      Taille_Unite:=LaTaille_Unite;
      if UpperCase(Unite.Text)=UpperCase(tuDistance[cm]) then Unite_Defaut:=tuDistance[cm]
      else if UpperCase(Unite.Text)=UpperCase(tuDistance[m]) then Unite_Defaut:=tuDistance[m];
      Separateur:=self.Separateur.Text[1];
      Deux_Colonne:=Colonne.Checked;
    end;
    if Ptt_Text='Croquis' then with En_Cours.Schema do Taille:=LaTaille;
    if Ptt_Text='Commentaires' then with En_Cours.Commentaire do Taille:=LaTaille;
    if Ptt_Text='Point topo' then with En_Cours.Point do Taille:=LaTaille;
    if Ptt_Text='Dv. horizontal' then with En_Cours.Correction_Horizontale do begin
      Taille:=LaTaille;
      TailleDef:=LaTailleDef;
      Existe:=Manuel.Checked;
    end;
    if Ptt_Text='Dveloppement' then with En_Cours.Correction_Dlt do begin
      Taille:=LaTaille;
      TailleDef:=LaTailleDef;
      Existe:=Manuel.Checked;
    end;
  end;
(*****************************************)
  Ptt_Text:=ListBox1.Items[ListBox1.ItemIndex];
  if Ptt_Text='Longueur' then with En_Cours.Longueur do begin
    self.Taille.Text:=IntToStr(Taille);
    self.Taille_Unite.Text:=IntToStr(Taille_Unite);
    with Unite.Items do begin
      Clear; Add(tuDistance[m]); Add(tuDistance[cm]);
    end;
    Unite.Text:=Unite_defaut;
  end;
  if Ptt_Text='Azimut' then with En_Cours.Azimuth do begin
    self.Taille.Text:=IntToStr(Taille);
    self.Taille_Unite.Text:=IntToStr(Taille_Unite);
    with Unite.Items do begin
      Clear; Add(tuAngle[deg]); Add(tuAngle[gr]); Add(tuAngle[ndeg]); Add(tuAngle[ngr]);
    end;
    Unite.Text:=Unite_defaut;
  end;
  if Ptt_Text='Pente' then with En_Cours.Pente do begin
    self.Taille.Text:=IntToStr(Taille);
    self.Taille_Unite.Text:=IntToStr(Taille_Unite);
    with Unite.Items do begin
      Clear; Add(tuAngle[deg]); Add(tuAngle[gr]); Add(tuAngle[ndeg]); Add(tuAngle[ngr]);
      Add(tuAngle[mp]); Add(tuAngle[cmp]); Add(tuAngle[nmp]); Add(tuAngle[ncmp]);
      Add(tuAngle[vdeg]); Add(tuAngle[nvdeg]);
    end;
    Unite.Text:=Unite_defaut;
  end;
  if Ptt_Text='Largeur' then with En_Cours.Largeur do begin
    self.Taille.Text:=IntToStr(Taille);
    self.Taille_Unite.Text:=IntToStr(Taille_Unite);
    with Unite.Items do begin
      Clear; Add(tuDistance[m]); Add(tuDistance[cm]);
    end;
    Unite.Text:=Unite_defaut;
    self.Separateur.Text:=Separateur;
    Colonne.Checked:=Deux_Colonne;
  end;
  if Ptt_Text='Hauteur' then with En_Cours.Hauteur do begin
    self.Taille.Text:=IntToStr(Taille);
    self.Taille_Unite.Text:=IntToStr(Taille_Unite);
    with Unite.Items do begin
      Clear; Add(tuDistance[m]); Add(tuDistance[cm]);
    end;
    Unite.Text:=Unite_defaut;
    self.Separateur.Text:=Separateur;
    Colonne.Checked:=Deux_Colonne;
  end;
  if Ptt_Text='Croquis' then with En_Cours.Schema do self.Taille.Text:=IntToStr(Taille);
  if Ptt_Text='Commentaires' then with En_Cours.Commentaire do self.Taille.Text:=IntToStr(Taille);
  if Ptt_Text='Point topo' then with En_Cours.Point do self.Taille.Text:=IntToStr(Taille);
  if Ptt_Text='Dv. horizontal' then with En_Cours.Correction_Horizontale do begin
    self.Taille.Text:=IntToStr(Taille);
    self.Taille_Manuel.Text:=IntToStr(TailleDef);
    Manuel.Checked:=Existe;
  end;
  if Ptt_Text='Dveloppement' then with En_Cours.Correction_Dlt do begin
    self.Taille.Text:=IntToStr(Taille);
    self.Taille_Manuel.Text:=IntToStr(TailleDef);
    Manuel.Checked:=Existe;
  end;
// mettre les nouvelles

  Haut.Enabled:=(ListBox1.ItemIndex>1);
  Bas.Enabled:=(ListBox1.ItemIndex<9) and (ListBox1.ItemIndex>0);
  Unite.Enabled:=(Ptt_Text='Longueur') or (Ptt_Text='Azimut') or (Ptt_Text='Pente') or
                                             (Ptt_Text='Hauteur') or (Ptt_Text='Largeur');
  Taille_Unite.Enabled:=Unite.Enabled;
  Colonne.Enabled:=(Ptt_Text='Hauteur') or (Ptt_Text='Largeur');
  if not Colonne.Enabled then Colonne.Checked:=false;
  Separateur.Enabled:=Colonne.Checked;
  Manuel.Enabled:=(Ptt_Text='Dv. horizontal') or (Ptt_Text='Dveloppement');
  Taille_Manuel.Enabled:=Manuel.Enabled;
  Actuel:=ListBox1.ItemIndex;
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  En_Cours.Free; En_Cours:=nil;
end;

procedure TForm3.HautClick(Sender: TObject);
var
  I : integer;
begin
  Actuel:=Actuel-1;
  I:=ListBox1.ItemIndex;
  ListBox1.Items.Exchange(I,I-1);
  Haut.Enabled:=(I>2); Bas.Enabled:=true;
  ListBox1.ItemIndex:=I-1;
end;

procedure TForm3.BasClick(Sender: TObject);
var
  I : integer;
begin
  Actuel:=Actuel+1;
  I:=ListBox1.ItemIndex;
  ListBox1.Items.Exchange(I,I+1);
  Haut.Enabled:=true; Bas.Enabled:=(I<ListBox1.Items.Count-2);
  ListBox1.ItemIndex:=I+1;
end;

procedure TForm3.Button1Click(Sender: TObject);
begin
  Enregistrer;
end;

end.
