unit Marges;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Options, Dialogs, SysUtils;

type
  TDef_Marge = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    FontDialog1: TFontDialog;
    GroupBox1: TGroupBox;
    F_Afficher: TCheckBox;
    C_Fichier: TComboBox;
    Label7: TLabel;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    D_Afficher: TCheckBox;
    C_Date: TComboBox;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    P_Afficher: TCheckBox;
    C_Page: TComboBox;
    GroupBox4: TGroupBox;
    Label1: TLabel;
    EGauche: TEdit;
    Label2: TLabel;
    EDroite: TEdit;
    Label3: TLabel;
    EHaut: TEdit;
    Label4: TLabel;
    EBas: TEdit;
    GroupBox5: TGroupBox;
    Label5: TLabel;
    ELongueur: TEdit;
    Label6: TLabel;
    EEpaisseur: TEdit;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EGaucheKeyPress(Sender: TObject; var Key: Char);
    procedure F_AfficherClick(Sender: TObject);
    procedure P_AfficherClick(Sender: TObject);
    procedure D_AfficherClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Font_Standart : TFont;
    procedure Rempli(Une_Marge : TMarge);
  end;

var
  Def_Marge: TDef_Marge;

implementation

{$R *.DFM}

procedure TDef_Marge.Rempli(Une_Marge : TMarge);
begin
  EGauche.Text:=IntTostr(Une_Marge.Gauche);
  EDroite.Text:=IntTostr(Une_Marge.Droite);
  EHaut.Text:=IntTostr(Une_Marge.Haut);
  EBas.Text:=IntTostr(Une_Marge.Bas);
  ELongueur.Text:=IntTostr(Une_Marge.Longueur);
  EEpaisseur.Text:=IntTostr(Une_Marge.Epaisseur);
  F_Afficher.Checked:=Une_Marge.Afficher[1];
  P_Afficher.Checked:=Une_Marge.Afficher[2];
  D_Afficher.Checked:=Une_Marge.Afficher[3];

  C_Fichier.ItemIndex:=Une_Marge.Angle[1]-1;
  C_Page.ItemIndex:=Une_Marge.Angle[2]-1;
  C_Date.ItemIndex:=Une_Marge.Angle[3]-1;
  Font_Standart.Assign(Une_Marge.Police);
end;

procedure TDef_Marge.Button1Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Standart);
  if FontDialog1.Execute then Font_Standart.Assign(FontDialog1.Font);
end;

procedure TDef_Marge.FormCreate(Sender: TObject);
begin
  Font_Standart:=TFont.create;
end;

procedure TDef_Marge.EGaucheKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) then Key := #0;
end;

procedure TDef_Marge.F_AfficherClick(Sender: TObject);
begin
  C_Fichier.Enabled:=F_Afficher.Checked;
end;

procedure TDef_Marge.P_AfficherClick(Sender: TObject);
begin
  C_Page.Enabled:=P_Afficher.Checked;
end;

procedure TDef_Marge.D_AfficherClick(Sender: TObject);
begin
  C_Date.Enabled:=D_Afficher.Checked;
end;

end.
