unit Opt_plan;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons, SysUtils,
  StdCtrls, ExtCtrls, Dialogs, Options, TabNotBk, ComCtrls;

type
  TOpti_Plan = class(TForm)
    FontDialog1: TFontDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    Affiche_Nord: TCheckBox;
    Representation: TRadioGroup;
    Label9: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    Label8: TLabel;
    Affiche_Echelle: TCheckBox;
    Epaisseur_Echelle: TEdit;
    X_Echelle: TEdit;
    Y_Echelle: TEdit;
    Police_Echelle: TButton;
    Subdivision: TEdit;
    Largeur_Echelle: TEdit;
    Long_Echelle: TEdit;
    GroupBox3: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    Epaisseur_Visee: TEdit;
    pourcentage: TEdit;
    Label19: TLabel;
    Label14: TLabel;
    Texte_Station: TRadioGroup;
    diametre: TEdit;
    Police_Station: TButton;
    Label18: TLabel;
    Label17: TLabel;
    Label16: TLabel;
    Affiche_Quadri: TCheckBox;
    Epaisseur_Quadri: TEdit;
    Longueur_Quadri: TEdit;
    Pas: TEdit;
    Label20: TLabel;
    Angle: TEdit;
    Label21: TLabel;
    Label22: TLabel;
    X_Origine: TEdit;
    Origine: TCheckBox;
    Y_Origine: TEdit;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Epaisseur_Nord: TEdit;
    Label3: TLabel;
    Long_Nord: TEdit;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    X_Nord: TEdit;
    Label2: TLabel;
    Y_Nord: TEdit;
    GroupBox4: TGroupBox;
    Texte_Nord: TEdit;
    Police_Nord: TButton;
    Button1: TButton;
    Button2: TButton;
    GroupBox5: TGroupBox;
    Label15: TLabel;
    Afficher_Habillage: TCheckBox;
    Epaisseur_Habit: TEdit;
    GroupBox6: TGroupBox;
    Label25: TLabel;
    Representation_Largeur: TRadioGroup;
    Epaisseur_Largeur: TEdit;
    AuDebut: TCheckBox;
    AlaFin: TCheckBox;
    Label5: TLabel;
    Label23: TLabel;
    procedure Affiche_NordClick(Sender: TObject);
    procedure Police_NordClick(Sender: TObject);
    procedure Affiche_EchelleClick(Sender: TObject);
    procedure Afficher_HabillageClick(Sender: TObject);
    procedure Affiche_QuadriClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Police_EchelleClick(Sender: TObject);
    procedure Police_StationClick(Sender: TObject);
    procedure X_NordKeyPress(Sender: TObject; var Key: Char);
    procedure Epaisseur_NordKeyPress(Sender: TObject; var Key: Char);
    procedure OrigineClick(Sender: TObject);
    procedure Representation_LargeurClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Font_Nord, Font_Echelle, Font_Station : TFont;
    procedure Rempli(Une_Option : TOptions_Plan);
  end;

var
  Opti_Plan: TOpti_Plan;

implementation

{$R *.DFM}

procedure TOpti_Plan.Affiche_NordClick(Sender: TObject);
begin
  X_Nord.Enabled:=Affiche_Nord.Checked;
  Y_Nord.Enabled:=Affiche_Nord.Checked;
  Representation.Enabled:=Affiche_Nord.Checked;
  Epaisseur_Nord.Enabled:=Affiche_Nord.Checked;
  Long_Nord.Enabled:=Affiche_Nord.Checked;
  Texte_Nord.Enabled:=Affiche_Nord.Checked;
  Police_Nord.Enabled:=Affiche_Nord.Checked;
end;

procedure TOpti_Plan.Police_NordClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Nord);
  if FontDialog1.Execute then Font_Nord.Assign(FontDialog1.Font);
end;

procedure TOpti_Plan.Affiche_EchelleClick(Sender: TObject);
begin
  Epaisseur_Echelle.Enabled:=Affiche_Echelle.Checked;
  X_Echelle.Enabled:=Affiche_Echelle.Checked;
  Y_Echelle.Enabled:=Affiche_Echelle.Checked;
  Long_Echelle.Enabled:=Affiche_Echelle.Checked;
  Largeur_Echelle.Enabled:=Affiche_Echelle.Checked;
  Subdivision.Enabled:=Affiche_Echelle.Checked;
  Police_Echelle.Enabled:=Affiche_Echelle.Checked;
end;

procedure TOpti_Plan.Afficher_HabillageClick(Sender: TObject);
begin
  Epaisseur_Habit.Enabled:=Afficher_Habillage.Checked;
end;

procedure TOpti_Plan.Affiche_QuadriClick(Sender: TObject);
begin
  Epaisseur_Quadri.Enabled:=Affiche_Quadri.Checked;
  Longueur_Quadri.Enabled:=Affiche_Quadri.Checked;
  Pas.Enabled:=Affiche_Quadri.Checked;
end;

procedure TOpti_Plan.Rempli(Une_Option : TOptions_Plan);
begin
  Font_Nord.Assign(Une_Option.Nord_Police);
  Font_Echelle.Assign(Une_Option.Echelle_Police);
  Font_Station.Assign(Une_Option.Station_Police);
  Affiche_Nord.Checked:=Une_Option.Nord_Affiche;
  Affiche_Echelle.Checked:=Une_Option.Echelle_Affiche;
  Afficher_Habillage.Checked:=Une_Option.Habit_Affiche;
  Affiche_Quadri.Checked:=Une_Option.Quadri_Affiche;
  Representation_Largeur.ItemIndex:=Une_Option.Type_Largeur;
  AuDebut.Checked:=Une_Option.Debut;
  ALaFin.Checked:=Une_Option.Fin;
  Epaisseur_Largeur.Text:=IntTostr(Une_Option.Epaisseur_Largeur);
  if Une_Option.NG then Representation.ItemIndex:=1
                   else Representation.ItemIndex:=0;
  Texte_Nord.Text:=Une_Option.Texte_Nord;
  X_Nord.Text:=FloatTostrF(Une_Option.Nord_X,ffGeneral,6,3);
  Y_Nord.Text:=FloatTostrF(Une_Option.Nord_Y,ffGeneral,6,3);
  X_Echelle.Text:=FloatTostrF(Une_Option.Echelle_X,ffGeneral,6,3);
  Y_Echelle.Text:=FloatTostrF(Une_Option.Echelle_Y,ffGeneral,6,3);
  Epaisseur_Nord.Text:=IntTostr(Une_Option.Nord_Epaisseur);
  Long_Nord.Text:=IntTostr(Une_Option.Nord_Longueur);
  Epaisseur_Echelle.Text:=IntTostr(Une_Option.Echelle_Epaisseur);
  Long_Echelle.Text:=IntTostr(Une_Option.Echelle_Longueur);
  Largeur_Echelle.Text:=IntTostr(Une_Option.Echelle_Largeur);
  Subdivision.Text:=IntTostr(Une_Option.Echelle_Sub);
  Epaisseur_Visee.Text:=IntTostr(Une_Option.Visee_Epaisseur);
  Pourcentage.Text:=IntTostr(Une_Option.Pourcent);
  Diametre.Text:=IntTostr(Une_Option.Diametre);
  Epaisseur_Habit.Text:=IntTostr(Une_Option.Habit_Epaisseur);
  Texte_Station.ItemIndex:=Une_Option.Carrefour;
  Pas.Text:=IntTostr(Une_Option.Quadri_Pas);
  Epaisseur_Quadri.Text:=IntTostr(Une_Option.Quadri_Epaisseur);
  Longueur_Quadri.Text:=IntTostr(Une_Option.Quadri_Longueur);
  Angle.Text:=FloatTostrF(Une_Option.Rotation,ffGeneral,4,1);
  Origine.Checked:=Une_Option.Blocage_Origine;
  X_Origine.Text:=FloatTostrF(Une_Option.Origine_X,ffGeneral,6,3);
  Y_Origine.Text:=FloatTostrF(Une_Option.Origine_Y,ffGeneral,6,3);
  Affiche_NordClick(Self);
  Affiche_EchelleClick(Self);
  Affiche_QuadriClick(Self);
end;


procedure TOpti_Plan.FormCreate(Sender: TObject);
begin
  Font_Nord:=TFont.Create;
  Font_Echelle:=TFont.Create;
  Font_Station:=TFont.Create;
end;

procedure TOpti_Plan.FormDestroy(Sender: TObject);
begin
  Font_Nord.Free; Font_Nord:=nil;
  Font_Echelle.Free; Font_Echelle:=nil;
  Font_Station.Free; Font_Station:=nil;
end;

procedure TOpti_Plan.Police_EchelleClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Echelle);
  if FontDialog1.Execute then Font_Echelle.Assign(FontDialog1.Font);
end;

procedure TOpti_Plan.Police_StationClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Station);
  if FontDialog1.Execute then Font_Station.Assign(FontDialog1.Font);
end;

procedure TOpti_Plan.X_NordKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) and (Key<>'.') and (Key<>'-')
      then Key := #0;
end;

procedure TOpti_Plan.Epaisseur_NordKeyPress(Sender: TObject;
  var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) then Key := #0;
end;

procedure TOpti_Plan.OrigineClick(Sender: TObject);
begin
  X_Origine.Enabled:=Origine.Checked;
  Y_Origine.Enabled:=Origine.Checked;
end;

procedure TOpti_Plan.Representation_LargeurClick(Sender: TObject);
begin
  AuDebut.Enabled:=Representation_Largeur.ItemIndex<>0;
  AlaFin.Enabled:=Representation_Largeur.ItemIndex<>0;
  Epaisseur_Largeur.Enabled:=Representation_Largeur.ItemIndex<>0;
end;

end.
