unit Opt_tabl;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons, SysUtils,
  StdCtrls, ExtCtrls, Options, Dialogs, Tabs, TabNotBk, ComCtrls;

type
  TOpt_Tableau = class(TForm)
    FontDialog1: TFontDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ListBox1: TListBox;
    Jaffiche: TCheckBox;
    Haut: TBitBtn;
    Bas: TBitBtn;
    Largeur: TEdit;
    Tete1: TEdit;
    Tete2: TEdit;
    Double: TCheckBox;
    Separation: TEdit;
    Label6: TLabel;
    ListBox2: TListBox;
    Hauteur: TEdit;
    Rappel: TCheckBox;
    Label13: TLabel;
    ListBox3: TListBox;
    HauteurR: TEdit;
    RappelR: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Ptt_Trait: TEdit;
    Gros_Trait: TEdit;
    Hauteur_Ligne: TEdit;
    Button2: TButton;
    Button1: TButton;
    Label16: TLabel;
    EnPlan: TCheckBox;
    EnAltitude: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    GroupBox1: TGroupBox;
    Jaffiche3: TCheckBox;
    La_PoliceR: TButton;
    Label9: TLabel;
    IntituleR: TEdit;
    Label10: TLabel;
    X_PosR: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Y_PosR: TEdit;
    GroupBox2: TGroupBox;
    Jaffiche2: TCheckBox;
    La_Police: TButton;
    Label7: TLabel;
    Intitule: TEdit;
    X: TLabel;
    X_Pos: TEdit;
    Y: TLabel;
    Y_Pos: TEdit;
    Position: TLabel;
    GroupBox3: TGroupBox;
    Nom: TLabel;
    Label15: TLabel;
    Point_Topo: TEdit;
    Indice: TEdit;
    BitBtn1: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure HautClick(Sender: TObject);
    procedure BasClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure JafficheClick(Sender: TObject);
    procedure DoubleClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Jaffiche2Click(Sender: TObject);
    procedure La_PoliceClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure LargeurKeyPress(Sender: TObject; var Key: Char);
    procedure ListBox3Click(Sender: TObject);
    procedure La_PoliceRClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Jaffiche3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Ordre : array[0..12] of shortInt;
    Larg : array[1..13] of byte;
    EnteteA, EnteteB : array[1..13] of string;
    Separat : array[1..13] of char;
    Affich, Dedoubl : array[1..13] of boolean;
    Actuel, Precedent, PrecedentR : shortInt;
    Font_Standart, Font_Relief : TFont;
    So_Afficher : array[1..11,0..1] of boolean;
    So_Intitule : array[1..11,0..1] of string;
    So_X, So_Y : array[1..11,0..1] of smallInt;
    So_Police : array[1..11,0..1] of TFont;
    So_Hauteur : array[0..1] of SmallInt;
    So_Rappel: array[0..1] of boolean;
    procedure Rempli(Une_Option : TOptions_Tableau);
  end;

var
  Opt_Tableau: TOpt_Tableau;

implementation


{$R *.DFM}

uses FicheTpo, Recherch, Unit1;

procedure TOpt_Tableau.FormShow(Sender: TObject);
begin
  ListBox1.ItemIndex:=0;
  Haut.Enabled:=false;
  Actuel:=20;
  Precedent:=20;
  PrecedentR:=20;
  Hauteur.Text:=IntTostr(So_Hauteur[0]);
  Rappel.Checked:=So_Rappel[0];
  HauteurR.Text:=IntTostr(So_Hauteur[1]);
  RappelR.Checked:=So_Rappel[1];
end;

procedure TOpt_Tableau.ListBox1Click(Sender: TObject);
var
  I : shortInt;
begin
  if Actuel<>20 then begin
    Actuel:=Ordre[Actuel];
    Affich[Actuel]:=Jaffiche.Checked;
    Larg[Actuel]:=StrToIntE(Largeur.Text);
    EnteteA[Actuel]:=Tete1.Text;
    EnteteB[Actuel]:=Tete2.Text;
    Dedoubl[Actuel]:=Double.Checked;
    Separat[Actuel]:=Separation.Text[1];
  end;
  I:=ListBox1.ItemIndex;
  Haut.Enabled:=(I<>0);
  Bas.Enabled:=(I<>12);
  case Ordre[I] of
    coLongueur, coAzimuth, coPente, coX, coY, coZ, coLH, coDZ, 
    coDevH, coObservation, coDlt : begin
      Tete2.Visible:=false;
      Double.Visible:=false;
      Label3.Visible:=false;
      Separation.Visible:=false;
    end;
    coLargeur, coHauteur : begin
      Tete2.Visible:=true;
      Double.Visible:=true;
      Label3.Visible:=true;
      Separation.Visible:=true;
    end;
  end;
  Jaffiche.Checked:=Affich[Ordre[I]];
  Largeur.Text:=IntTostr(Larg[Ordre[I]]);
  Tete1.Text:=EnteteA[Ordre[I]];
  Tete2.Text:=EnteteB[Ordre[I]];
  Double.Checked:=Dedoubl[Ordre[I]];
  Separation.Text:=Separat[Ordre[I]];
  Largeur.Enabled:=Jaffiche.Checked;
  Tete1.Enabled:=Jaffiche.Checked;
  Tete2.Enabled:=Jaffiche.Checked and Double.Checked;
  Double.Enabled:=Jaffiche.Checked;
  Separation.Enabled:=Jaffiche.Checked and not Double.Checked;
  Actuel:=I;

end;

procedure TOpt_Tableau.HautClick(Sender: TObject);
var
  I, Ptt_Entier : shortInt;
begin
  I:=ListBox1.ItemIndex;
  ListBox1.Items.Exchange(I,I-1);
  Haut.Enabled:=(I<>1); Bas.Enabled:=true;
  Ptt_Entier:=Ordre[I];
  Ordre[I]:=Ordre[I-1];
  Ordre[I-1]:=Ptt_Entier;
  Actuel:=Actuel-1;
  ListBox1.ItemIndex:=I-1;
end;

procedure TOpt_Tableau.BasClick(Sender: TObject);
var
  I, Ptt_Entier : shortInt;
begin
  I:=ListBox1.ItemIndex;
  ListBox1.Items.Exchange(I,I+1);
  Haut.Enabled:=true; Bas.Enabled:=(I<>9);
  Ptt_Entier:=Ordre[I];
  Ordre[I]:=Ordre[I+1];
  Ordre[I+1]:=Ptt_Entier;
  Actuel:=Actuel+1;
  ListBox1.ItemIndex:=I+1;
end;

procedure TOpt_Tableau.FormActivate(Sender: TObject);
begin
  ListBox1Click(Sender);
  ListBox2.ItemIndex:=0;
  ListBox2Click(Sender);
  ListBox3.ItemIndex:=0;
  ListBox3Click(Sender);
end;


procedure TOpt_Tableau.JafficheClick(Sender: TObject);
begin
  Largeur.Enabled:=Jaffiche.Checked;
  Tete1.Enabled:=Jaffiche.Checked;
  Tete2.Enabled:=Jaffiche.Checked and Double.Checked;
  Double.Enabled:=Jaffiche.Checked;
  Separation.Enabled:=Jaffiche.Checked and not Double.Checked;
end;

procedure TOpt_Tableau.DoubleClick(Sender: TObject);
begin
  Tete2.Enabled:=Jaffiche.Checked and Double.Checked;
  Separation.Enabled:=Jaffiche.Checked and not Double.Checked;
end;

procedure TOpt_Tableau.Rempli(Une_Option : TOptions_Tableau);
var
  I, J : shortInt;
  S : string;
begin
  for I:=1 to 13 do begin
    Ordre[Une_Option.Rang[I]-1]:=I;
    Larg[I]:=Une_Option.Largeur[I];
    Separat[I]:=Une_Option.Separateur[I];
    Affich[I]:=Une_Option.Afficher[I];
    Dedoubl[I]:=Une_Option.Dedoubler[I];
    EnteteA[I]:=Une_Option.Entete[I,1];
    EnteteB[I]:=Une_Option.Entete[I,2];
  end;
  Ptt_Trait.Text:=IntToStr(Une_Option.Epaisseur_Visee);
  Gros_Trait.Text:=IntTostr(Une_Option.Epaisseur_Direction);
  Hauteur_Ligne.Text:=IntTostr(Une_Option.Hauteur);
  ListBox1.Items.Clear;
  for I:=0 to 12 do begin
    case Ordre[I] of
      coLongueur : ListBox1.Items.Add('Longueur');
      coAzimuth : ListBox1.Items.Add('Azimut');
      coPente : ListBox1.Items.Add('Pente');
      coLargeur  : ListBox1.Items.Add('Largeur');
      coHauteur : ListBox1.Items.Add('Hauteur');
      coX : ListBox1.Items.Add('X');
      coY : ListBox1.Items.Add('Y');
      coZ : ListBox1.Items.Add('Z');
      coDevH : ListBox1.Items.Add('Dv. horizontal');
      coObservation : ListBox1.Items.Add('Commentaires');
      coDlt : ListBox1.Items.Add('Dveloppement');
      coLH : ListBox1.Items.Add('Long. horizontale');
      coDZ : ListBox1.Items.Add('Delta Z');
    end;
  end;
  Font_Standart.Assign(Une_Option.Police);
  Font_Relief.Assign(Une_Option.Relief);
  for J:=0 to 1 do begin
    for I:=1 to 11 do begin
      So_Afficher[I,J]:=Une_Option.So_Afficher[I,J];
      So_Intitule[I,J]:=Une_Option.So_Intitule[I,J];
      So_X[I,J]:=Une_Option.So_X[I,J];
      So_Y[I,J]:=Une_Option.So_Y[I,J];
      So_Police[I,J].Assign(Une_Option.So_Police[I,J]);
    end;
    So_Hauteur[J]:=Une_Option.So_Hauteur[J];
    So_Rappel[J]:=Une_Option.So_Rappel[J];
  end;
  Hauteur.Text:=IntTostr(So_Hauteur[0]);
  Rappel.Checked:=So_Rappel[0];
  HauteurR.Text:=IntTostr(So_Hauteur[1]);
  RappelR.Checked:=So_Rappel[1];

  EnPlan.Checked:=Une_Option.BloqueXY;
  EnAltitude.Checked:=Une_Option.BloqueZ;
  Indice.Text:=IntTostr(Une_Option.Point.Indice);
  Une_Option.Point.Nom.Lit(S); Point_Topo.Text:=S;
end;


procedure TOpt_Tableau.OKBtnClick(Sender: TObject);
begin
  if Actuel<>20 then begin
    Actuel:=Ordre[Actuel];
    Affich[Actuel]:=Jaffiche.Checked;
    Larg[Actuel]:=StrToIntE(Largeur.Text);
    EnteteA[Actuel]:=Tete1.Text;
    EnteteB[Actuel]:=Tete2.Text;
    Dedoubl[Actuel]:=Double.Checked;
    Separat[Actuel]:=Separation.Text[1];
  end;
  if Precedent<>20 then begin
    So_Afficher[Precedent,0]:=Jaffiche2.Checked;
    So_Intitule[Precedent,0]:=Intitule.Text;
    So_X[Precedent,0]:=StrToIntE(X_Pos.Text);
    So_Y[Precedent,0]:=StrToIntE(Y_Pos.Text);
  end;
  So_Hauteur[0]:=StrToIntE(Hauteur.Text);
  So_Rappel[0]:=Rappel.Checked;

  if PrecedentR<>20 then begin
    So_Afficher[PrecedentR,1]:=Jaffiche3.Checked;
    So_Intitule[PrecedentR,1]:=IntituleR.Text;
    So_X[PrecedentR,1]:=StrToIntE(X_PosR.Text);
    So_Y[PrecedentR,1]:=StrToIntE(Y_PosR.Text);
  end;
  So_Hauteur[1]:=StrToIntE(HauteurR.Text);
  So_Rappel[1]:=RappelR.Checked;
end;

procedure TOpt_Tableau.Button1Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Standart);
  if FontDialog1.Execute then Font_Standart.Assign(FontDialog1.Font);
end;

procedure TOpt_Tableau.ListBox2Click(Sender: TObject);
var
  I : integer;
begin
  if Precedent<>20 then begin
    So_Afficher[Precedent,0]:=Jaffiche2.Checked;
    So_Intitule[Precedent,0]:=Intitule.Text;
    So_X[Precedent,0]:=StrToIntE(X_Pos.Text);
    So_Y[Precedent,0]:=StrToIntE(Y_Pos.Text);
  end;
  I:=ListBox2.ItemIndex+1;
  Jaffiche2.Checked:=So_Afficher[I,0];
  Intitule.Text:=So_Intitule[I,0];
  X_Pos.Text:=IntToStr(So_X[I,0]);
  Y_Pos.Text:=IntToStr(So_Y[I,0]);
  Precedent:=I;
  Intitule.Enabled:=So_Afficher[I,0];
  X_Pos.Enabled:=So_Afficher[I,0];
  Y_Pos.Enabled:=So_Afficher[I,0];
  La_Police.Enabled:=So_Afficher[I,0];
end;

procedure TOpt_Tableau.FormCreate(Sender: TObject);
var
  I, J : integer;
begin
  Font_Standart:=TFont.create;
  Font_Relief:=TFont.create;
  for I:=1 to 11 do for J:=0 to 1 do So_Police[i,j]:=TFont.Create;
end;

procedure TOpt_Tableau.Jaffiche2Click(Sender: TObject);
begin
  Intitule.Enabled:=Jaffiche2.Checked;
  X_Pos.Enabled:=Jaffiche2.Checked;
  Y_Pos.Enabled:=Jaffiche2.Checked;
  La_Police.Enabled:=Jaffiche2.Checked;
end;

procedure TOpt_Tableau.La_PoliceClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(So_Police[Precedent,0]);
  if FontDialog1.Execute then So_Police[Precedent,0].Assign(FontDialog1.Font);
end;

procedure TOpt_Tableau.Button2Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(Font_Relief);
  if FontDialog1.Execute then Font_Relief.Assign(FontDialog1.Font);
end;

procedure TOpt_Tableau.LargeurKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) then Key := #0;
end;

procedure TOpt_Tableau.ListBox3Click(Sender: TObject);
var
  I : integer;
begin
  if PrecedentR<>20 then begin
    So_Afficher[PrecedentR,1]:=Jaffiche3.Checked;
    So_Intitule[PrecedentR,1]:=IntituleR.Text;
    So_X[PrecedentR,1]:=StrToIntE(X_PosR.Text);
    So_Y[PrecedentR,1]:=StrToIntE(Y_PosR.Text);
  end;
  I:=ListBox3.ItemIndex+1;
  Jaffiche3.Checked:=So_Afficher[I,1];
  IntituleR.Text:=So_Intitule[I,1];
  X_PosR.Text:=IntToStr(So_X[I,1]);
  Y_PosR.Text:=IntToStr(So_Y[I,1]);
  PrecedentR:=I;
  IntituleR.Enabled:=So_Afficher[I,1];
  X_PosR.Enabled:=So_Afficher[I,1];
  Y_PosR.Enabled:=So_Afficher[I,1];
  La_PoliceR.Enabled:=So_Afficher[I,1];
end;

procedure TOpt_Tableau.La_PoliceRClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(So_Police[PrecedentR,1]);
  if FontDialog1.Execute then So_Police[PrecedentR,1].Assign(FontDialog1.Font);
end;

procedure TOpt_Tableau.BitBtn1Click(Sender: TObject);
var
  Quelle_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Position : integer;
  Grand_Nom, Ptt_Text : string;
  Choix : smallInt;
begin
  if Form1.Massif<>nil then begin
    Grand_Nom:='';
    Position:=0;
    if Recherche_Simple(Form1.Massif.Liste_Fiche,Form1.Massif,Quelle_Fiche,Position,Grand_Nom,'','','','')
    then begin
      if Position=-1 then begin
        ShowMessage('Il faut obligatoirement passer par la visualisation avec cette mthode');
  {      Position:=-1; }
      end
      else begin
        Une_Galerie:=Quelle_Fiche.Liste_Galerie[Position];
        Choix:=0;
        if not Une_Galerie.Depart.Terminus then Choix:=1;
        if not Une_Galerie.Arrivee.Terminus then Choix:=Choix+1;
        case Choix of
          0 : MessageDlg('La galerie slectionne n''a que des terminus',mtWarning,[mbOk],0);
          1 : if not Une_Galerie.Depart.Terminus then begin
            Une_Galerie.Depart.Nom.Lit(Ptt_Text);
            Point_Topo.Text:=Ptt_Text;
            Indice.Text:=IntToStr(Une_Galerie.Depart.Indice);
          end
          else begin
            Une_Galerie.Arrivee.Nom.Lit(Ptt_Text);
            Point_Topo.Text:=Ptt_Text;
            Indice.Text:=IntToStr(Une_Galerie.Arrivee.Indice);
          end;
          2 : begin
            Une_Galerie.Depart.Nom.Lit(Ptt_Text);
            Ptt_Text:=Ptt_Text+'('+IntToStr(Une_Galerie.Depart.Indice)+')';
            Une_Galerie.Arrivee.Nom.Lit(Grand_Nom);
            Grand_Nom:=Grand_Nom+'('+IntToStr(Une_Galerie.Arrivee.Indice)+')';
            if MessageDlg('Deux points possibles : '+Grand_Nom+' (Oui) et '+Ptt_Text+' (Ok)',
               mtConfirmation,[mbOk,mbYes],0)=mrOk then begin
              Une_Galerie.Depart.Nom.Lit(Ptt_Text);
              Point_Topo.Text:=Ptt_Text;
              Indice.Text:=IntToStr(Une_Galerie.Depart.Indice);
            end
            else begin
              Une_Galerie.Arrivee.Nom.Lit(Ptt_Text);
              Point_Topo.Text:=Ptt_Text;
              Indice.Text:=IntToStr(Une_Galerie.Arrivee.Indice);
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TOpt_Tableau.Jaffiche3Click(Sender: TObject);
begin
  IntituleR.Enabled:=Jaffiche3.Checked;
  X_PosR.Enabled:=Jaffiche3.Checked;
  Y_PosR.Enabled:=Jaffiche3.Checked;
  La_PoliceR.Enabled:=Jaffiche3.Checked;
end;

end.
