unit Propos;

interface

uses ShellApi, Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, SysUtils;

type
  TApropos = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Label1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Apropos: TApropos;

implementation

{$R *.DFM}

procedure TApropos.Label1Click(Sender: TObject);
begin
  ShellExecute(0, nil,'mailto:courrier@ericsibert.com?Subject=CyberTopo' , nil, nil,SW_SHOWNORMAL);
end;

procedure TApropos.FormShow(Sender: TObject);
var
  FISize,dummy:   Dword;
  Buff:     pointer;
  BuffSize: integer;
  FI:       PVSFixedFileInfo;
begin

  BuffSize := GetFileVersionInfoSize(PChar(Application.ExeName), dummy);
  if BuffSize = 0 then exit;  // Fail: Version not managed

  GetMem(Buff, BuffSize);
  try
    GetFileVersionInfo(PChar(Application.ExeName), dummy, BuffSize, Buff);
    if VerQueryValue(Buff, '\', Pointer(FI), FISize) then begin
      Version.Caption := Format('Version %d.%d.%d.%d', [
                           FI.dwFileVersionMS shr 16,
                           FI.dwFileVersionMS AND $FFFF,
                           FI.dwFileVersionLS shr 16,
                           FI.dwFileVersionLS AND $FFFF]);
    end;
  finally
    FreeMem(Buff);
  end;

end;

end.
 
