{$N-}
unit Unit2;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, Tabs,
  Buttons, ExtCtrls, Grids, Dialogs, FicheTpo, Prefecra, Mask, {Simple, }
  Excelimp, Menus, Correcti, Pt_Topo, Informat, ClipBrd, SysUtils, Messages,
  SendKey, UAjuste, BufferedFile;

type

  TNoeud = class(TObject)
    Precedent, Suivant : TPointTopo;
    Info : TEco;
    FDefor, Du_Topofil : reel;
    Couleur : TColor;
    constructor Create;
    property Defor : reel read FDefor write FDefor;
    procedure Sauvegarder(var F : TFileBufferStream);
    procedure Recuperer(var F : TFileBufferStream);
  end;

  TMultPageDlg = class(TForm)
    TabSet: TTabSet;
    Notebook: TNotebook;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Systeme: TEdit;
    Cavite: TEdit;
    Reseau: TEdit;
    Lieu: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Declinaison: TEdit;
    Topographes: TLabel;
    Topographe: TMemo;
    Label8: TLabel;
    Button8: TButton;
    Date: TMaskEdit;
    PopupMenu1: TPopupMenu;
    Importer: TMenuItem;
    Insreruneligne1: TMenuItem;
    Supprimeruneligne1: TMenuItem;
    Corrigerlalongueur1: TMenuItem;
    Corrigerlazimuth1: TMenuItem;
    Corrigerlapente1: TMenuItem;
    Insrerunpoint1: TMenuItem;
    Supprimerunpoint1: TMenuItem;
    Label7: TLabel;
    Liste: TBitBtn;
    TPST: TEdit;
    Label9: TLabel;
    Premiere: TEdit;
    MainMenu1: TMainMenu;
    Fiche1: TMenuItem;
    Terminer1: TMenuItem;
    Suivante1: TMenuItem;
    N1: TMenuItem;
    Annuler1: TMenuItem;
    N2: TMenuItem;
    Enregistrer1: TMenuItem;
    Edition1: TMenuItem;
    Couper1: TMenuItem;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    Supprimer2: TMenuItem;
    N3: TMenuItem;
    Importerduntableur1: TMenuItem;
    Point1: TMenuItem;
    Nouveau1: TMenuItem;
    Modifier1: TMenuItem;
    Commentaire1: TMenuItem;
    Tableau1: TMenuItem;
    Continuerenbas1: TMenuItem;
    CorrigerlaLongueur2: TMenuItem;
    CorrigerlAzimut1: TMenuItem;
    CorrigerlaPente2: TMenuItem;
    Supprimer3: TMenuItem;
    N4: TMenuItem;
    Insrerunevise1: TMenuItem;
    Supprimerunevise1: TMenuItem;
    N5: TMenuItem;
    Toutcopier1: TMenuItem;
    UniteDecli: TComboBox;
    TableauVisee: TStringGrid;
    Unite: TComboBox;
    N6: TMenuItem;
    N7: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure TabSetClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ImporterClick(Sender: TObject);
    procedure Corrigerlalongueur1Click(Sender: TObject);
    procedure Insreruneligne1Click(Sender: TObject);
    procedure Supprimeruneligne1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Insrerunpoint1Click(Sender: TObject);
    procedure Supprimerunpoint1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure ListeClick(Sender: TObject);
    procedure Terminer1Click(Sender: TObject);
    procedure Suivante1Click(Sender: TObject);
    procedure Annuler1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure Nouveau1Click(Sender: TObject);
    procedure Modifier1Click(Sender: TObject);
    procedure Commentaire1Click(Sender: TObject);
    procedure Supprimer3Click(Sender: TObject);
    procedure Point1Click(Sender: TObject);
    procedure Importerduntableur1Click(Sender: TObject);
    procedure Continuerenbas1Click(Sender: TObject);
    procedure Tableau1Click(Sender: TObject);
    procedure Insrerunevise1Click(Sender: TObject);
    procedure Supprimerunevise1Click(Sender: TObject);
    procedure Coller1Click(Sender: TObject);
    procedure Copier1Click(Sender: TObject);
    procedure Couper1Click(Sender: TObject);
    procedure Supprimer2Click(Sender: TObject);
    procedure Toutcopier1Click(Sender: TObject);
    procedure DeclinaisonKeyPress(Sender: TObject; var Key: Char);
    procedure TableauViseeClick(Sender: TObject);
    procedure TableauViseeDblClick(Sender: TObject);
    procedure TableauViseeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TableauViseeMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure TableauViseeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TableauViseeKeyPress(Sender: TObject; var Key: Char);
    procedure UniteExit(Sender: TObject);
    procedure UniteKeyPress(Sender: TObject; var Key: Char);
    procedure UniteKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DateChange(Sender: TObject);
    procedure TableauViseeSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
  private
    { Private declarations }
  public
    { Public declarations }
    Ancienne : boolean;
    Ordre, Nb_Origine : longint;
    Le_Massif : TMassif;
    La_Fiche : TFiche;
    Le_Format : TPreference_Ecran;
    List_Noeud : TList;
    Premier, Dernier : TPointTopo;
    PremierInfo : TEco;
    PremierDefo, PremierTopofil : reel;
    PremiereCouleur : TColor;
    DernierExiste, Ouverture, Modification : boolean;
    Selection_En_Cours : boolean;
    Debut, Souri_Ligne, Souri_Colonne : longint;
    Exemple : array[0..19] of String;
    procedure Contenu(Releve : TFiche; Ensemble : TMassif;
        Format : TPreference_Ecran; Num_Galerie : smallInt);
    procedure Remplir(Num_Galerie : SmallInt);
    function Enregistrer:boolean;
    procedure ViderPage1;
    procedure ToutVider;
    procedure Nouvel_Aspect;
    procedure Insere_Lgn(Position : SmallInt; Nature, T1, T2 : string);
    function BaseFiche(Position : smallInt) : boolean;
    procedure Sauvegarder(var F : TFileBufferStream);
    procedure Recuperer(var F : TFileBufferStream);
    procedure Editer_Depart;
    procedure Editer_Arrivee;
    procedure Editer_Commentaire;
    procedure Formatage(Affichage : TPreference_Ecran);
    procedure Ajouter_Ligne;
  end;

var
  MultPageDlg: TMultPageDlg;

implementation

uses Unit1, Calcul, L_Explor;
{$R *.DFM}

Constructor TNoeud.Create;
begin
  Precedent:=TPointTopo.Create;
  Suivant:=TPointTopo.Create;
  Info:=TEco.Create;
end;

procedure TNoeud.Sauvegarder(var F : TFileBufferStream);
begin
  assert(Precedent<>nil,'Precedent vide dans TNoeud.Sauvegarder');
  assert(Suivant<>nil,'Suivant vide dans TNoeud.Sauvegarder');
  assert(Info<>nil,'Info vide dans TNoeud.Sauvegarder');
  Precedent.Sauve(F);
  Suivant.Sauve(F);
  Info.Sauve(F);
  F.write(Defor,sizeOf(Defor));
  F.write(Du_Topofil,sizeOf(Du_Topofil));
end;

procedure TNoeud.Recuperer(var F : TFileBufferStream);
begin
  assert(Precedent<>nil,'Precedent vide dans TNoeud.Recuperer');
  assert(Suivant<>nil,'Suivant vide dans TNoeud.Recuperer');
  assert(Info<>nil,'Info vide dans TNoeud.Recuperer');
  Precedent.Loade(F);
  Suivant.Loade(F);
  Info.Loade(F);
  F.Read(FDefor,sizeOf(FDefor));
  F.Read(Du_Topofil,sizeOf(Du_Topofil));
end;


procedure TMultPageDlg.FormCreate(Sender: TObject);
begin
  { make the number of Tabs = number of Pages,
    and have the same names }

  TabSet.Tabs := Notebook.Pages;
  List_Noeud:=TList.Create;
  List_Noeud.Capacity:=5;
  PixelsPerInch:=Screen.PixelsPerInch;
end;

procedure TMultPageDlg.TabSetClick(Sender: TObject);
begin
  { set visible Page to which Tab was clicked }
  Notebook.PageIndex := TabSet.TabIndex;
  if not Ancienne and (TabSet.TabIndex=0) and Ouverture then begin
    Ouverture:=false;
    Souri_Ligne:=2;
    with TableauVisee do begin
      Row:=1;
      Col:=1;
      Editer_Depart;
      Col:=2;
      Editer_Commentaire;
      Row:=2;
    end;
  end;
end;

procedure TMultPageDlg.Contenu(Releve : TFiche; Ensemble : TMassif;
    Format: TPreference_Ecran; Num_Galerie : smallInt);
var
  T1 : string;
begin
  La_Fiche:=Releve;
  Le_Massif:=Ensemble;
  Le_Format:=Format;
  Formatage(Le_Format);
  Ancienne:=Releve<>nil;
  if Ancienne then begin
    Remplir(Num_Galerie);
  end
  else begin
    Ouverture:=true;
    Premier:=TPointTopo.Create;
    PremierInfo:=TEco.Create;
    Premier.Terminus:=true;
    Insere_Lgn(1,'|->','Terminus','');
    T1:='';
    PremierInfo.Ecrit(T1);
    PremierTopofil:=1;
    PremierDefo:=1;
    DernierExiste:=false;
    TabSet.TabIndex:=1;
  end;
  Ordre:=0;
  Modification:=false;
end;

procedure TMultPageDlg.Remplir(Num_Galerie : SmallInt);
var
  Ptt_Text : string;
  I, Decalage, Numero_Visee : integer;
  Topog : TEco;
  Une_Galerie : TGalerie;
  Un_Noeud : TNoeud;

  procedure Centre;
  var
    I,J : SmallInt;
  begin
    for I:=1 to Une_Galerie.Nb_Visee do begin
      Ajouter_Ligne;
      TableauVisee.Cells[0,Numero_Visee+Decalage]:=IntToStr(Numero_Visee);
      for J:=1 to Le_Format.Nb_Colonne do begin
        case Le_Format.Visuel[J].Intitule of
          coLONG : begin
            if Une_Galerie.Visees[I].Topofil then begin
              Ptt_Text:=IntToStr(round(Une_Galerie.Visees[I].Debut_Topofil))+'/'+
                IntToStr(round(Une_Galerie.Visees[I].Debut_Topofil+
                 Une_Galerie.Visees[I].Longueur/Une_Galerie.Correction_Topofil));
            end
            else Ptt_Text:=FloatTostrF(Une_Galerie.Visees[I].Longueur,ffGeneral,5,3);
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
          coAZ : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              FloatTostrF(Une_Galerie.Visees[I].Azimuth,ffGeneral,5,3);
          coPENTE : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              FloatTostrF(Une_Galerie.Visees[I].Pente,ffGeneral,5,3);
          coULONG : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
                tuDistance[Une_Galerie.Visees[I].ULong];
          coUAZ : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
                tuAngle[Une_Galerie.Visees[I].UAzimuth];
          coUPENTE : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              tuAngle[Une_Galerie.Visees[I].UPente];
          coLARGG : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              Une_Galerie.Visees[I].LargeurGauche;
          coLARGD : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              Une_Galerie.Visees[I].LargeurDroite;
          coLARG : begin
            if Une_Galerie.Visees[I].LargeurDroite<>'' then Ptt_Text:=
             Une_Galerie.Visees[I].LargeurGauche+Le_Format.Largeur.Separateur
                +Une_Galerie.Visees[I].LargeurDroite
                else Ptt_Text:=Une_Galerie.Visees[I].LargeurGauche;
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
          coULARG : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              tuDistance[Une_Galerie.Visees[I].ULarg];
          coHAUTH  : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              Une_Galerie.Visees[I].HauteurSup;
          coHAUTB : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              Une_Galerie.Visees[I].HauteurInf;
          coHAUT : begin
            if Une_Galerie.Visees[I].HauteurInf<>'' then Ptt_Text:=
               Une_Galerie.Visees[I].HauteurSup+Le_Format.Hauteur.Separateur
                +Une_Galerie.Visees[I].HauteurInf
              else Ptt_Text:=Une_Galerie.Visees[I].HauteurSup;
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
          coUHAUT : TableauVisee.Cells[J,Numero_Visee+Decalage]:=
              tuDistance[Une_Galerie.Visees[I].UHauteur];
          coSCHEMA : begin
            if Une_Galerie.Visees[I].Schema=0 then Ptt_Text:='' else
                                   Ptt_Text:=IntToStr(Une_Galerie.Visees[I].Schema);
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
          coCOMMENT : begin
            Une_Galerie.Visees[I].Commentaires.Lit(Ptt_Text);
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
          coDEFCOR : begin
            if Une_Galerie.Visees[I].Correction_Horizontale then Ptt_Text:='O'
                                                           else Ptt_Text:='N';
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
          coCORH : begin
            Ptt_Text:=FloatTostrF(Une_Galerie.Visees[I].Longueur_Horizontale,ffGeneral,4,3);
            if not Une_Galerie.Visees[I].Correction_Horizontale and
               (Une_Galerie.Visees[I].Longueur_Horizontale<1e-5) then Ptt_Text:='';
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
          coDEFDLT : begin
            if Une_Galerie.Visees[I].Correction_Dlt then Ptt_Text:='O'
                                                           else Ptt_Text:='N';
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
          coCORDLT : begin
            Ptt_Text:=FloatToStrF(Une_Galerie.Visees[I].Longueur_Dlt,ffGeneral,4,3);
            if not Une_Galerie.Visees[I].Correction_Dlt and
               (Une_Galerie.Visees[I].Longueur_Dlt<1e-5) then Ptt_Text:='';
            TableauVisee.Cells[J,Numero_Visee+Decalage]:=Ptt_Text;
          end;
        end;
      end;
      inc(Numero_Visee);
    end;
  end;

var
  T1, T2 : string;

begin
  La_Fiche.Systeme.Lit(Ptt_Text);
  Systeme.Text:=Ptt_Text;
  La_Fiche.Cavite.Lit(Ptt_Text);
  Cavite.Text:=Ptt_Text;
  La_Fiche.Reseau.Lit(Ptt_Text);
  Reseau.Text:=Ptt_Text;
  La_Fiche.Lieu.Lit(Ptt_Text);
  Lieu.Text:=Ptt_Text;
  Declinaison.text:=FloatToStrF(La_Fiche.Declinaison,ffGeneral,5,3);
  Premiere.text:=FloatToStrF(La_Fiche.Premiere,ffGeneral,5,2);
  La_Fiche.Temps.Lit(Ptt_Text);
  TPST.Text:=Ptt_Text;
  UniteDecli.text:=tuAngle[La_Fiche.Unite_Decli];
  Date.Text:=La_Fiche.Date;
  for I:=0 to La_Fiche.Topographes.Count-1 do begin
    Topog:=La_Fiche.Topographes[I];
    Topog.Lit(Ptt_Text);
    Topographe.Lines.Add(Ptt_Text);
  end;
  Numero_Visee:=1;
  Decalage:=1;
  Une_Galerie:=La_Fiche.Liste_Galerie[0];
  Nb_Origine:=0;
  Premier:=TPointTopo.Create;
  Premier.Duplique(Une_Galerie.Depart);
  if Premier.Terminus then begin
    T1:='Terminus';
    T2:='';
  end
  else begin
    Premier.Nom.Lit(T1);
    T1:=T1+'('+IntToStr(Premier.indice)+')';
  end;
  PremierInfo:=TEco.Create;
  PremierInfo.Duplique(Une_Galerie.Information);
  PremiereCouleur:=Une_Galerie.Couleur;
  PremierDefo:=Une_Galerie.Precision;
  PremierTopofil:=Une_Galerie.Correction_Topofil;
  PremierInfo.Lit(T2);
  Insere_Lgn(1,'|->',T1,T2);
  for I:=0 to La_Fiche.Liste_Galerie.Count-1 do begin
    if I=Num_Galerie then with TableauVisee do begin
      Row:=Decalage+Numero_Visee;
      Col:=2;
      TopRow:=Row;
    end;
    Une_Galerie:=La_Fiche.Liste_Galerie[I];
    if I>0 then begin
      Un_Noeud.Suivant.Duplique(Une_Galerie.Depart);
      if Un_Noeud.Suivant.Terminus then begin
        T1:='Terminus';
        T2:='';
      end
      else begin
        Un_Noeud.Suivant.Nom.Lit(T1);
        if T1='' then
          T1:='*';
        T1:=T1+'('+IntToStr(Un_Noeud.Suivant.Indice)+')';
      end;
      Un_Noeud.Info.Duplique(Une_Galerie.Information);
      Un_Noeud.Couleur:=Une_Galerie.Couleur;
      Un_Noeud.Info.Lit(T2);
      Insere_Lgn(Numero_Visee+Decalage-1,'|->',T1,T2);
      Un_Noeud.Defor:=Une_Galerie.Precision;
      Un_Noeud.Du_Topofil:=Une_Galerie.Correction_Topofil;
    end;
    Centre;
    if I<La_Fiche.Liste_Galerie.Count-1 then begin
      Un_Noeud:=TNoeud.Create;
      Un_Noeud.Precedent.Duplique(Une_Galerie.Arrivee);
      if Un_Noeud.Precedent.Terminus then begin
        T1:='Terminus';
        T2:='';
      end
      else begin
        Un_Noeud.Precedent.Nom.Lit(T1);
        T1:=T1+'('+IntTostr(Un_Noeud.Precedent.Indice)+')';
      end;
      Insere_Lgn(Numero_Visee+Decalage,'->|',T1,'');
      List_Noeud.Add(Un_Noeud);
      Decalage:=Decalage+2;
    end;
  end;
  Dernier:=TPointTopo.Create;
  Dernier.Duplique(Une_Galerie.Arrivee);
  if Dernier.Terminus then begin
    T1:='Terminus';
    T2:='';
  end
  else begin
    Dernier.Nom.Lit(T1);
    T1:=T1+'('+IntTostr(Dernier.Indice)+')';
  end;
  if Num_Galerie=-1 then begin
    TableauVisee.Row:=2; TableauVisee.Col:=2;
  end;
  Insere_Lgn(Numero_Visee+Decalage,'->|',T1,'');
  DernierExiste:=true;
  TableauVisee.RowCount:=Numero_Visee+2*La_Fiche.Liste_Galerie.Count;
end;

function TMultPageDlg.Enregistrer : boolean;
var
  Ptt_Text, Deux : string;
  Ptt_Nombre, Ptt_Reel : reel;
  I, J, Rempli : integer;
  Echec, Complet, TropCourt : boolean;
  Une_Fiche : TFiche;
  Une_Galerie : TGalerie;
  Topog : TEco;
  Numero_Visee, Numero_Fiche, Decalage : SmallInt;
  Un_Noeud : TNoeud;
  Equivalent : array[0..340] of smallInt;

  procedure Dereal(var Text1, Text2 : string; Separation : char);
  var
    C : SmallInt;
  begin
    if Text1='' then Text2:=''
    else begin
      C:=1;
      while (C<length(Text1)) and (Text1[C]<>Separation) do inc(C);
      if Text1[C]=Separation then begin
        Text2:=copy(Text1,C+1,length(Text1));
        Text1:=copy(Text1,1,C-1);
      end
      else Text2:='';
    end;
  end;

  procedure Retour(I, J : longint);
  begin
    TabSet.TabIndex:=0;
    TableauVisee.SetFocus;
    TableauVisee.Col:=J;
    TableauVisee.Row:=I;
    TableauVisee.TopRow:=I;
  end;

begin
  Une_Fiche:=TFiche.Create;
  Une_Galerie:=nil;
  try
    if not DernierExiste then begin
      MessageDlg('La fiche ne se termine pas sur un point topo',mtWarning,[mbOk],0);
      abort;
    end;
    Une_Fiche.Systeme.Ecrit(Systeme.Text);
    Une_Fiche.Cavite.Ecrit(Cavite.Text);
    Une_Fiche.Reseau.Ecrit(Reseau.Text);
    Une_Fiche.Lieu.Ecrit(Lieu.Text);
    try
      Une_Fiche.Declinaison:=StrToFloat(Declinaison.Text);
    except
      MessageDlg('La dclinaison doit tre numrique'+#13+'exemple'+' 2.53',mtInformation,
           [mbOk],0);
      TabSet.TabIndex:=1;
      Declinaison.SetFocus;
      raise;
    end;

    Ptt_Text:=UpperCase(UniteDecli.text);
    if Ptt_Text=UpperCase(tuAngle[deg]) then Une_Fiche.Unite_Decli:=deg
    else if Ptt_Text=UpperCase(tuAngle[gr]) then Une_Fiche.Unite_Decli:=gr
    else begin
      MessageDlg(Format('La dclinaison doit tre en %s ou en %s.',[tuAngle[deg],tuAngle[gr]]),
      mtConfirmation,[mbOk],0);
      TabSet.TabIndex:=1;
      UniteDecli.SetFocus;
      abort;
    end;

    try
      Une_Fiche.Premiere:=StrToFloat(Premiere.Text);
    except
      MessageDlg('La premire doit tre numrique'+#13+'exemple'+' 103.5',mtInformation,
           [mbOk],0);
      TabSet.TabIndex:=1;
      Premiere.SetFocus;
      raise;
    end;

    Une_Fiche.Temps.Ecrit(TPST.Text);
    Une_Fiche.Date:=Date.Text;
    if Date.Text[1]=' ' then Une_Fiche.Date[1]:='0';
    if Date.Text[4]=' ' then Une_Fiche.Date[4]:='0';
    for I:=1 to Topographe.Lines.Count do begin
      Ptt_Text:=Topographe.Lines[I-1];
      Topog:=TEco.Create; Topog.Ecrit(Ptt_Text);
      Une_Fiche.Topographes.Add(Topog);
    end;

    for I:=0 to 340 do Equivalent[I]:=-1;
    Numero_Visee:=1;
    Numero_Fiche:=0;
    Decalage:=1;
    Complet:=false;

    Une_Galerie:=TGalerie.Create;
    Une_Galerie.Depart.Duplique(Premier);
    Une_Galerie.Information.Duplique(PremierInfo);
    Une_Galerie.Precision:=PremierDefo;
    Une_Galerie.Correction_Topofil:=PremierTopofil;
    Une_Galerie.Couleur:=PremiereCouleur;

    repeat
      I:=Numero_Visee+Decalage;
      Rempli:=0;
      if TableauVisee.Cells[0,I]=('->|') then begin
        TropCourt:=(((Numero_Visee=1) and not Une_Galerie.Fantome) or
                    ((Numero_Visee=2) and Une_Galerie.Fantome))
          and not Une_Galerie.Depart.Terminus;
        if Numero_Fiche=List_Noeud.Count then begin
          if TropCourt and not Dernier.Terminus then begin
            MessageDlg('Il doit y avoir au moins une vise entre deux carrefours',mtWarning,[mbOk],0);
            Retour(I,1);
            abort;
          end
          else begin
            Complet:=true;
            Une_Galerie.Arrivee.Duplique(Dernier);
            Une_Galerie.Nb_Visee:=Numero_Visee-1;
            Une_Fiche.Liste_Galerie.Add(Une_Galerie);
          end;
        end
        else begin
          Un_Noeud:=List_Noeud[Numero_Fiche];
          if TropCourt and not Un_Noeud.Precedent.Terminus then begin
            MessageDlg('Il doit y avoir au moins une vise entre deux carrefours',mtWarning,[mbOk],0);
            Retour(I,1);
            abort;
          end
          else begin
            Une_Galerie.Arrivee.Duplique(Un_Noeud.Precedent);
            Une_Galerie.Nb_Visee:=Numero_Visee-1;
            Une_Fiche.Liste_Galerie.Add(Une_Galerie);
            inc(Numero_Fiche);
            Une_Galerie:=TGalerie.Create;
            Une_Galerie.Depart.Duplique(Un_Noeud.Suivant);
            Une_Galerie.Information.Duplique(Un_Noeud.Info);
            Une_Galerie.Couleur:=Un_Noeud.Couleur;
            Une_Galerie.Precision:=Un_Noeud.Defor;
            Une_Galerie.Correction_Topofil:=Un_Noeud.Du_Topofil;
            Decalage:=Decalage+Numero_Visee+1;
            Numero_Visee:=0;
          end;
        end;
      end
      else begin
        Une_Galerie.Visees[Numero_Visee]:=TVisee.Create;
        Une_Galerie.Nb_Visee:=Numero_Visee;
        for J:=2 to Le_Format.Nb_Colonne do begin
          case Le_Format.Visuel[J].Intitule of
            coLONG : begin
              inc(Rempli);
              try
                Une_Galerie.Visees[Numero_Visee].Longueur:=StrToFloat(TableauVisee.Cells[J,I]);
              except
                Ptt_Text:=TableauVisee.Cells[J,I];
                if pos('/',Ptt_Text)<>0 then begin // topofil
                  Deux:=Copy(Ptt_Text,pos('/',Ptt_Text)+1,length(Ptt_Text));
                  Ptt_Text:=Copy(Ptt_Text,1,pos('/',Ptt_Text)-1);
                  try
                    Une_Galerie.Visees[Numero_Visee].Debut_Topofil:=strToFloat(Ptt_Text);
                    Une_Galerie.Visees[Numero_Visee].Longueur:=(strToFloat(Deux)-
                       Une_Galerie.Visees[Numero_Visee].Debut_Topofil)*Une_Galerie.Correction_Topofil;
                    Une_Galerie.Visees[Numero_Visee].Topofil:=true;
                  except
                    MessageDlg('Les longueurs Topofil ne sont pas correctes',mtWarning,[mbOk],0);
                    Retour(I,J);
                    raise;
                  end;
                  if (Une_Galerie.Visees[Numero_Visee].Longueur<1e-2) then begin
                    MessageDlg('La longueur Topofil est ngative',mtWarning,[mbOk],0);
                    Retour(I,J);
                    abort;
                  end;
                end
                else begin
                  MessageDlg('La longueur n''est pas correcte',mtWarning,[mbOk],0);
                  Retour(I,J);
                  raise;
                end;
              end;
              if Une_Galerie.Visees[Numero_Visee].Longueur<-1e-3 then begin
                MessageDlg('La longueur doit tre positive',mtWarning,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
              if (abs(Une_Galerie.Visees[Numero_Visee].Longueur)<1e-3) then begin
                if (Numero_Visee<>1) then begin
                  MessageDlg('La longueur ne doit pas tre nulle',mtWarning,[mbOk],0);
                  Retour(I,J);
                  Abort;
                end
                else Une_Galerie.Fantome:=true;
              end;
            end;
            coAZ : begin
              inc(Rempli);
              try
                Une_Galerie.Visees[Numero_Visee].Azimuth:=StrToFloat(TableauVisee.Cells[J,I]);
              except
                MessageDlg('L''azimut n''est pas correct',mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coPENTE : begin
              inc(Rempli);
              try
                Une_Galerie.Visees[Numero_Visee].Pente:=StrToFloat(TableauVisee.Cells[J,I]);
              except
                MessageDlg('La pente n''est pas correcte',mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coULONG : begin
              Ptt_Text:=UpperCase(TableauVisee.Cells[J,I]);
              if Ptt_Text=UpperCase(tuDistance[m]) then Une_Galerie.Visees[Numero_Visee].ULong:=m
               else if Ptt_Text=UpperCase(tuDistance[cm]) then
                Une_Galerie.Visees[Numero_Visee].ULong:=cm
              else begin
                MessageDlg(Format('L''unit de longueur doit tre en %s ou %s.',[tuDistance[m],tuDistance[cm]]),
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coUAZ : begin
              Ptt_Text:=UpperCase(TableauVisee.Cells[J,I]);
              if Ptt_Text=UpperCase(tuAngle[deg]) then Une_Galerie.Visees[Numero_Visee].UAzimuth:=deg
               else if Ptt_Text=UpperCase(tuAngle[gr]) then Une_Galerie.Visees[Numero_Visee].UAzimuth:=gr
                else if Ptt_Text=UpperCase(tuAngle[ndeg]) then Une_Galerie.Visees[Numero_Visee].UAzimuth:=ndeg
                 else if Ptt_Text=UpperCase(tuAngle[ngr]) then Une_Galerie.Visees[Numero_Visee].UAzimuth:=ngr
              else begin
                MessageDlg(Format('L''unit d''azimut doit tre en %s ou %s.',[tuAngle[deg],tuAngle[gr]]),
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coUPENTE : begin
              Ptt_Text:=UpperCase(TableauVisee.Cells[J,I]);
              if Ptt_Text=UpperCase(tuAngle[mp]) then Une_Galerie.Visees[Numero_Visee].UPente:=mp
              else if Ptt_Text=UpperCase(tuAngle[cmp]) then Une_Galerie.Visees[Numero_Visee].UPente:=cmp
              else if Ptt_Text=UpperCase(tuAngle[deg]) then Une_Galerie.Visees[Numero_Visee].UPente:=deg
              else if Ptt_Text=UpperCase(tuAngle[gr]) then Une_Galerie.Visees[Numero_Visee].UPente:=gr
              else if Ptt_Text=UpperCase(tuAngle[vdeg]) then Une_Galerie.Visees[Numero_Visee].UPente:=vdeg
              else if Ptt_Text=UpperCase(tuAngle[nmp]) then Une_Galerie.Visees[Numero_Visee].UPente:=nmp
              else if Ptt_Text=UpperCase(tuAngle[ncmp]) then Une_Galerie.Visees[Numero_Visee].UPente:=ncmp
              else if Ptt_Text=UpperCase(tuAngle[ndeg]) then Une_Galerie.Visees[Numero_Visee].UPente:=ndeg
              else if Ptt_Text=UpperCase(tuAngle[ngr]) then Une_Galerie.Visees[Numero_Visee].UPente:=ngr
              else if Ptt_Text=UpperCase(tuAngle[nvdeg]) then Une_Galerie.Visees[Numero_Visee].UPente:=nvdeg
              else begin
                MessageDlg('L''unit de pente n''est pas correcte.',mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coLARGG : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              if Length(Ptt_Text)>10 then begin
                MessageDlg('La dfinition de la largeur gauche doit tre infrieure  dix.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
              Une_Galerie.Visees[Numero_Visee].LargeurGauche:=Ptt_Text;
            end;
            coLARGD : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              if Length(Ptt_Text)>10 then begin
                MessageDlg('La dfinition de la largeur droite doit tre infrieure  dix.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
              Une_Galerie.Visees[Numero_Visee].LargeurDroite:=Ptt_Text;
            end;
            coLARG : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              Dereal(Ptt_Text,Deux,Le_Format.Largeur.Separateur);
              if (Length(Ptt_Text)>10) or (length(Deux)>10) then begin
                MessageDlg('La dfinition de la largeur doit tre infrieure  dix.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
              Une_Galerie.Visees[Numero_Visee].LargeurGauche:=Ptt_Text;
              Une_Galerie.Visees[Numero_Visee].LargeurDroite:=Deux;
            end;
            coULARG : begin
              Ptt_Text:=UpperCase(TableauVisee.Cells[J,I]);
              if Ptt_Text=UpperCase(tuDistance[m]) then Une_Galerie.Visees[Numero_Visee].ULarg:=m
               else if Ptt_Text=UpperCase(tuDistance[cm]) then
                Une_Galerie.Visees[Numero_Visee].ULarg:=cm
              else begin
                MessageDlg(Format('L''unit de largeur doit tre en %s ou %s.',[tuDistance[m],tuDistance[cm]]),
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coHAUTH : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              if Length(Ptt_Text)>10 then begin
                MessageDlg('La dfinition de la hauteur suprieure doit tre infrieure  dix caractres.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
              Une_Galerie.Visees[Numero_Visee].HauteurSup:=Ptt_Text;
            end;
            coHAUTB : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              if Length(Ptt_Text)>10 then begin
                MessageDlg('La dfinition de la hauteur infrieure doit tre infrieure  dix caractres.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
              Une_Galerie.Visees[Numero_Visee].HauteurInf:=Ptt_Text;
            end;
            coHAUT : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              Dereal(Ptt_Text,Deux,Le_Format.Hauteur.Separateur);
              if (Length(Ptt_Text)>10) or (length(Deux)>10) then begin
                MessageDlg('La dfinition de la hauteur doit tre infrieure  dix caractres.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
              Une_Galerie.Visees[Numero_Visee].HauteurSup:=Ptt_Text;
              Une_Galerie.Visees[Numero_Visee].HauteurInf:=Deux;
            end;
            coUHAUT : begin
              Ptt_Text:=UpperCase(TableauVisee.Cells[J,I]);
              if Ptt_Text=UpperCase(tuDistance[m]) then Une_Galerie.Visees[Numero_Visee].UHauteur:=m
               else if Ptt_Text=UpperCase(tuDistance[cm]) then
                Une_Galerie.Visees[Numero_Visee].UHauteur:=cm
              else begin
                MessageDlg(Format('L''unit de hauteur doit tre en %s ou %s.',[tuDistance[m],tuDistance[cm]]),
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coSCHEMA : begin
              if TableauVisee.Cells[J,I]='' then Une_Galerie.Visees[Numero_Visee].Schema:=0
              else try
                Une_Galerie.Visees[Numero_Visee].Schema:=StrToInt(TableauVisee.Cells[J,I]);
              except
                MessageDlg('La taille du schma doit tre numrique.',mtConfirmation,[mbOk],0);
                Retour(I,J);
                raise;
              end;
            end;
            coCOMMENT : Une_Galerie.Visees[Numero_Visee].Commentaires.Ecrit(TableauVisee.Cells[J,I]);
            coDEFCOR : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              Ptt_Text[1]:=UpCase(Ptt_Text[1]);
              if Ptt_Text='O' then Une_Galerie.Visees[Numero_Visee].Correction_Horizontale:=true
              else if Ptt_Text='N' then Une_Galerie.Visees[Numero_Visee].Correction_Horizontale:=false
              else begin
                MessageDlg('Mettre O ou N pour la demande de correction horizontale.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coCORH : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              if TableauVisee.Cells[J,I]='' then Une_Galerie.Visees[Numero_Visee].Longueur_Horizontale:=0
              else try
                Une_Galerie.Visees[Numero_Visee].Longueur_Horizontale:=strToFloat(TableauVisee.Cells[J,I]);
              except
                MessageDlg('La correction horizontale doit tre numrique.',mtConfirmation,[mbOk],0);
                Retour(I,J);
                raise;
              end;
            end;
            coDEFDLT : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              Ptt_Text[1]:=UpCase(Ptt_Text[1]);
              if Ptt_Text='O' then Une_Galerie.Visees[Numero_Visee].Correction_Dlt:=true
              else if Ptt_Text='N' then Une_Galerie.Visees[Numero_Visee].Correction_Dlt:=false
              else begin
                MessageDlg('Mettre O ou N pour la demande de correction de dveloppemnt.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                Abort;
              end;
            end;
            coCORDLT : begin
              Ptt_Text:=TableauVisee.Cells[J,I];
              if TableauVisee.Cells[J,I]='' then Une_Galerie.Visees[Numero_Visee].Longueur_Dlt:=0
              else try
                Une_Galerie.Visees[Numero_Visee].Longueur_Dlt:=StrToFloat(TableauVisee.Cells[J,I]);
              except
                MessageDlg('La correction du dveloppement doit tre numrique.',
                    mtConfirmation,[mbOk],0);
                Retour(I,J);
                raise;
              end;
            end;
          end;
        end;
        if (Une_Galerie.Visees[Numero_Visee].UPente=mp) or
                         (Une_Galerie.Visees[Numero_Visee].UPente=cmp) then begin
          Ptt_Nombre:=abs(Une_Galerie.Visees[Numero_Visee].Pente);
          if Une_Galerie.Visees[Numero_Visee].UPente=cmp then Ptt_Nombre:=Ptt_Nombre/100;
          Ptt_Reel:=Une_Galerie.Visees[Numero_Visee].Longueur;
          if Une_Galerie.Visees[Numero_Visee].ULong=cm then Ptt_Reel:=Ptt_Reel/100;
          if Ptt_Reel<Ptt_Nombre then begin
            MessageDlg('La pente doit tre infrieure  la longueur.',mtConfirmation,[mbOk],0);
            Retour(I,2);
            Abort;
          end;
        end;
        if (Une_Galerie.Visees[Numero_Visee].UPente=deg) and
         (abs(Une_Galerie.Visees[Numero_Visee].Pente)>=91) then begin
          MessageDlg('La pente doit tre infrieure  90.',mtConfirmation,[mbOk],0);
          Retour(I,2);
          Abort;
        end;
        if Une_Galerie.Visees[Numero_Visee].UPente=vdeg then begin
          Ptt_Nombre:=Une_Galerie.Visees[Numero_Visee].Pente;
          if (Ptt_Nombre>=181) or (Ptt_Nombre<=-1) then begin
            MessageDlg('La pente Vulcain doit tre entre 0 et 180.',mtConfirmation,[mbOk],0);
            Retour(I,2);
            Abort;
          end;
        end;
        if (Une_Galerie.Visees[Numero_Visee].UPente=gr) and
         (abs(Une_Galerie.Visees[Numero_Visee].Pente)>100.1) then begin
          MessageDlg('La pente doit tre infrieure  100.',mtConfirmation,[mbOk],0);
          Retour(I,2);
          Abort;
        end;
        if Une_Galerie.Visees[Numero_Visee].UAzimuth=deg then begin
          Ptt_Nombre:=Une_Galerie.Visees[Numero_Visee].Azimuth;
          if (Ptt_Nombre>=361) or (Ptt_Nombre<=-1) then begin
            MessageDlg('L''azimut doit tre compris entre 0 et 360.',mtConfirmation,[mbOk],0);
            Retour(I,2);
            Abort;
          end;
        end;
        if Une_Galerie.Visees[Numero_Visee].UAzimuth=gr then begin
          Ptt_Nombre:=Une_Galerie.Visees[Numero_Visee].Azimuth;
          if (Ptt_Nombre>=401) or (Ptt_Nombre<=-1) then begin
            MessageDlg('L''azimut doit tre compris entre 0 et 400 gr.',mtConfirmation,[mbOk],0);
            Retour(I,2);
            Abort;
          end;
        end;
        if Rempli<>3 then begin
          MessageDlg('La vise est incomplte.',mtwarning,[mbOk],0);
          Retour(I,1);
          Abort;
        end;
      end;
      inc(Numero_Visee);
    until Complet;

    if Calcul_En_Cours then Calcul_Arrete:=true;
    Une_Fiche.Compile(Le_Massif.Angle_Geodesique);
    if Ancienne then begin
      // on regarde si les deux fiches se ressemblent
      Echec:=false;
      if La_Fiche.Liste_Galerie.Count=Une_Fiche.Liste_Galerie.Count then begin
        for I:=0 to La_Fiche.Liste_Galerie.Count-1 do begin
          if not (TGalerie(La_Fiche.Liste_Galerie[I]).Depart.Identique(
              TGalerie(Une_Fiche.Liste_Galerie[I]).Depart) or (
              TGalerie(La_Fiche.Liste_Galerie[I]).Depart.Terminus and
              TGalerie(Une_Fiche.Liste_Galerie[I]).Depart.Terminus))
              then Echec:=true;
          if not (TGalerie(La_Fiche.Liste_Galerie[I]).Arrivee.Identique(
              TGalerie(Une_Fiche.Liste_Galerie[I]).Arrivee) or (
              TGalerie(La_Fiche.Liste_Galerie[I]).Arrivee.Terminus and
              TGalerie(Une_Fiche.Liste_Galerie[I]).Arrivee.Terminus))
              then Echec:=true;
        end;
      end
      else Echec:=true;
      if Echec then
        Tuer_Les_Coupe(La_Fiche)   // on supprime les coupes, les fiches sont trop diffrentes
      else begin  // on reporte les coupes dans la nouvelle fiche si elles se ressemblent
        for I:=0 to La_Fiche.Liste_Galerie.Count-1 do with TGalerie(La_Fiche.Liste_Galerie[I]) do begin
          TGalerie(Une_Fiche.Liste_Galerie[I]).En_Coupe:=En_Coupe;
          TGalerie(Une_Fiche.Liste_Galerie[I]).Nb_Suite:=Nb_Suite;
          TGalerie(Une_Fiche.Liste_Galerie[I]).Accrochage_Debut:=Accrochage_Debut;
          TGalerie(Une_Fiche.Liste_Galerie[I]).Gauche_Droite:=Gauche_Droite;
          TGalerie(Une_Fiche.Liste_Galerie[I]).Ordre_Suite:=Ordre_Suite;
          TGalerie(Une_Fiche.Liste_Galerie[I]).Galerie_Suite:=Galerie_Suite;
          TGalerie(Une_Fiche.Liste_Galerie[I]).Decal_Hori:=Decal_Hori;
          TGalerie(Une_Fiche.Liste_Galerie[I]).Decal_Z:=Decal_Z;
          TGalerie(Une_Fiche.Liste_Galerie[I]).Fin_Hori:=Fin_Hori;
        end;
      end;
  assert(La_Fiche<>nil,'La_Fiche vide dans l''enregistrement d''une fiche (remplacement ds le massif');
      Le_Massif.Remplacer(La_Fiche,Une_Fiche);
      La_Fiche.Free; La_Fiche:=nil;
    end
    else begin
      Le_Massif.Ajouter(Une_Fiche,Form1.Massif.Existe_Selection);
      if Ordre<>0 then Une_Fiche.Ordre:=Ordre;
    end;
    La_Fiche:=Une_Fiche;

    Enregistrer:=true;
  except
    Une_Galerie.Free;
    Une_Fiche.Free; Une_Fiche:=nil;
    Enregistrer:=false;
  end;
end;

procedure TMultPageDlg.ToutVider;
begin
  ViderPage1;
  Systeme.Text:='';
  Cavite.Text:='';
  Reseau.Text:='';
  Lieu.Text:='';
  Declinaison.text:='';
  UniteDecli.text:='';
  TPST.Text:='';
  Date.Text:='  /  /  ';
  Topographe.Lines.Clear;
end;

procedure TMultPageDlg.ViderPage1;
var
  I : integer;
begin
  Premier.Free; Premier:=nil;
  PremierInfo.Free; PremierInfo:=nil;
  Dernier.Free; Dernier:=nil; DernierExiste:=false;
  Premiere.Text:='0';
  for I:=0 to List_Noeud.Count-1 do TNoeud(List_Noeud[I]).Free;
  List_Noeud.Free;
  List_Noeud:=TList.Create;
end;

procedure TMultPageDlg.Button8Click(Sender: TObject);
var
  Estime : reel;

  function Lineaire(S : string):reel;
  var
    Ajout : reel;
  begin
    result:=StrToInt(S[7]+S[8]);
    try
      Ajout:=StrToInt(S[4]+S[5]);
      result:=result+(Ajout-1)/12;
    except
    end;
    try
      Ajout:=StrToInt(S[1]+S[2]);
      result:=result+(Ajout-1)/365;
    except
    end;
  end;

begin
  if (Date.Text[7]=' ') and (Date.Text[8]=' ') then begin
    MessageDlg('Il faut au moins l''anne dans la date pour calculer la dclinaison'+
         #13+'exemple'+' 03/01/99',mtInformation,[mbOk],0);
    Date.SetFocus;
  end
  else begin
    UniteDecli.Text:=tuAngle[deg];
    Estime:=Lineaire(Date.Text)-Lineaire(Le_Massif.Date_Decli);
    if Lineaire(Date.Text)<50 then Estime:=Estime+100;
    if Lineaire(Le_Massif.Date_Decli)<50 then Estime:=Estime-100;
    Estime:=Le_Massif.Origine_Decli-Le_Massif.Variation_Decli*Estime;
    Declinaison.Text:=FloatToStrF(Estime,ffGeneral,5,4);
  end;
end;

procedure TMultPageDlg.FormResize(Sender: TObject);
begin
  GroupBox1.Height:=NoteBook.Height-22;
  GroupBox1.Width:=NoteBook.Width-12;
  TableauVisee.Height:=GroupBox1.Height-70;
  TableauVisee.Width:=GroupBox1.Width-32;
end;

procedure TMultPageDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if ModalResult=mrCancel then begin
    if not Modification or
     (MessageDlg('Les modifications vont tre perdues.',mtWarning,[mbOk,mbCancel],0)=mrOk)
      then ToutVider
      else ModalResult:=mrNone;
  end
  else ToutVider;
  Form1.Etat_Menu;
end;

procedure TMultPageDlg.Nouvel_Aspect;
var
  I : SmallInt;
begin
  with Le_Format do begin
    for I:=1 to Nb_Colonne do begin
      case Visuel[I].Intitule of
        coPOINT : begin
          Point.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Point.Taille;
        end;
        coLONG : begin
          Longueur.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Longueur.Taille;
        end;
        coULONG : begin
          Longueur.Taille_Unite:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Longueur.Taille_Unite;
        end;
        coAZ : begin
          Azimuth.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Azimuth.Taille;
        end;
        coUAZ : begin
          Azimuth.Taille_Unite:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Azimuth.Taille_Unite;
        end;
        coPENTE : begin
          Pente.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Pente.Taille;
        end;
        coUPENTE : begin
          Pente.Taille_Unite:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Pente.Taille_Unite;
        end;
        coLARG : begin
          Largeur.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Largeur.Taille;
        end;
        coLARGG : begin
          Largeur.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Largeur.Taille;
        end;
        coLARGD : begin
          Largeur.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Largeur.Taille;
        end;
        coULARG : begin
          Largeur.Taille_Unite:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Largeur.Taille_Unite;
        end;
        coHAUT : begin
          Hauteur.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Hauteur.Taille;
        end;
        coHAUTH : begin
          Hauteur.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Hauteur.Taille;
        end;
        coHAUTB : begin
          Hauteur.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Hauteur.Taille;
        end;
        coUHAUT : begin
          Hauteur.Taille_Unite:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Hauteur.Taille_Unite;
        end;
        coSCHEMA : begin
          Schema.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Schema.Taille;
        end;
        coCOMMENT : begin
          Commentaire.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Commentaire.Taille;
        end;
        coDEFCOR : begin
          Correction_Horizontale.TailleDef:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Correction_Horizontale.TailleDef;
        end;
        coCORH : begin
          Correction_Horizontale.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Correction_Horizontale.Taille;
        end;
        coDEFDLT : begin
          Correction_Dlt.TailleDef:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Correction_Dlt.TailleDef;
        end;
        coCORDLT : begin
          Correction_Dlt.Taille:=TableauVisee.ColWidths[I];
          Visuel[I].Pixel:=Correction_Dlt.Taille;
        end;
      end;
    end;
  end;
end;

procedure TMultPageDlg.ImporterClick(Sender: TObject);
var
  Une_Chaine : String;
  Accepte : boolean;
  Ligne, Colonne_Lecture, Colonne_Ecriture, I, J, Decalage : integer;
  Taille, Position : word;
  P : Pchar;

  procedure Avance_Ligne;
  begin
    repeat
      inc(Position)
    until (Position>Taille) or (P[Position]=chr(10));
  end;

  function Avance_Case : string;
  var C : char; Ptte_Chaine : string;
  begin
    Ptte_Chaine:='';
    repeat
      if Position<=Taille then begin
        C:=P[Position];
        if C=',' then C:='.';
        if (C<>chr(10)) and (C<>chr(9)) and (C<>chr(13)) then Ptte_Chaine:=Ptte_Chaine+C;
        if C=chr(10) then Ptte_Chaine:=chr(13);
      end;
      inc(Position);
    until (Position>Taille) or (C=chr(10)) or (C=chr(9)) or (C=chr(13));
    Avance_Case:=Ptte_Chaine;
  end;

begin
  Ligne:=Souri_Ligne;
  if (Ligne=1) or (TableauVisee.Cells[0,Ligne-1]='->|') then
    MessageDlg('Impossible d''ajouter une vise ici.',mtWarning,[mbOk],0)
  else
  if not ClipBoard.HasFormat(cf_Text) then
    MessageDlg('Il n''y a pas de texte dans le Presse-Papier.',mtWarning,[mbOk],0)
  else begin
    GetMem(P,32000);
    Taille:=ClipBoard.GetTextBuf(P,32000);
    if Taille=32000 then MessageDlg('Le Presse-Papier est trop gros.',mtWarning,[mbOk],0)
    else begin
      ImportationExcel:=TImportationExcel.Create(self);
      if ImportationExcel.ShowModal=mrOk then begin
        Modification:=true;
        Screen.Cursor := crHourglass;
        Position:=0;
        repeat
          Colonne_Lecture:=1;
          Colonne_Ecriture:=2;
          repeat
            Une_Chaine:=Avance_Case;
            if (Une_Chaine<>chr(13)) and (Position<=Taille) then begin
              Accepte:=true;
              for I:=0 to ImportationExcel.Colonnes.Lines.Count-1 do begin
                if StrToInt(ImportationExcel.Colonnes.Lines[I])=Colonne_Lecture
                  then Accepte:=false;
              end;
              if Accepte then begin
                TableauVisee.Cells[Colonne_Ecriture,Ligne]:=Une_Chaine;
                repeat
                  inc(Colonne_Ecriture);
                until Le_Format.Visuel[Colonne_Ecriture].Intitule<64;
              end;
              inc(Colonne_Lecture);
            end;
          until (Une_Chaine=chr(13)) or (Position>Taille);
          inc(Ligne);
          Ajouter_Ligne;
          if Ligne>=10 then with TableauVisee do begin
            if (Ligne-1>=RowCount-1) and (RowCount<1000) then begin
              Decalage:=0;
              for J:=0 to RowCount-1 do if (Cells[0,J]='->|') or (Cells[0,J]='|->') then inc(Decalage);
              RowCount:=RowCount+1;
              for J:=0 to ColCount-1 do Cells[J,RowCount-1]:=Exemple[J];
              Cells[0,RowCount-1]:=IntTostr(RowCount-1-Decalage);
            end;
          end;
        until Position>Taille;
        TableauVisee.Refresh;
        Screen.Cursor := crDefault;
      end;
      ImportationExcel.Free;
    end;
    FreeMem(P,32000);
  end;
end;

procedure TMultPageDlg.Corrigerlalongueur1Click(Sender: TObject);
var
  Increment : reel;
  I, Colonne, Debut, Fin : integer;
begin
  Correction:=TCorrection.Create(self);
  Correction.Portee:=(TableauVisee.Selection.Left=TableauVisee.Selection.Right);
  if (Sender=CorrigerlaLongueur2) or (sender=CorrigerlaLongueur1) then
    Correction.Mesure:=1
    else if (sender=Corrigerlazimuth1) or (sender=Corrigerlazimut1) then
      Correction.Mesure:=2
      else if (sender=CorrigerlaPente2) or (sender=CorrigerlaPente1) then
        Correction.Mesure:=3
        else assert(false,'Sender inconnu dans corrigerlalongueur');
  if Correction.ShowModal=mrOk then begin
    Modification:=true;
    if Correction.Portee then begin
      Debut:=2; Fin:=TableauVisee.RowCount-1;
    end
    else begin
      Debut:=TableauVisee.Selection.Top; Fin:=TableauVisee.Selection.Bottom;
    end;
    Increment:=strToFloat(Correction.Edit1.Text);
    for I:=1 to Le_Format.Nb_Colonne do begin
      if ((Le_Format.Visuel[I].Intitule=coLONG) and (Correction.Mesure=1)) or
         ((Le_Format.Visuel[I].Intitule=coAz) and (Correction.Mesure=2)) or
         ((Le_Format.Visuel[I].Intitule=coPente) and (Correction.Mesure=3))
        then Colonne:=I;
    end;
    for I:=Debut to Fin do begin
      if (TableauVisee.Cells[0,I]<>'->|') and
         (TableauVisee.Cells[0,I]<>'|->') then begin
        try
          TableauVisee.Cells[Colonne,I]:=FloatToStrF(
            StrToFloat(TableauVisee.Cells[Colonne,I])+Increment,ffGeneral,5,3);
        except
        end;
      end;
    end;
    TableauVisee.Refresh;
  end;
  Correction.Free;
end;

procedure TMultPageDlg.Insreruneligne1Click(Sender: TObject);
var
  Ligne, I, J : integer;
  Ptt_Text : string;
begin
  with TableauVisee do begin
    Ligne:=Souri_Ligne;
    if (Ligne=1) or (Cells[0,Ligne-1]='->|') then
      MessageDlg('Impossible d''ajouter une vise ici.',mtWarning,[mbOk],0)
    else begin
      Modification:=true;
      if Cells[0,Ligne]='->|' then begin
        I:=0;
        repeat
          inc(I);
          Ptt_Text:=Cells[0,Ligne-I];
        until (Ligne=I) or
            ((Ptt_Text<>'->|') and (Ptt_Text<>'|->'));
        if I=Ligne then Ptt_Text:='1'
        else Ptt_Text:=IntToStr(StrToInt(Ptt_Text)+1);
      end
      else begin
        Ptt_Text:=Cells[0,Ligne];
      end;
      Ajouter_Ligne;
      for I:=RowCount-1 downto Ligne+1 do begin
        for J:=0 to ColCount-1 do Cells[J,I]:=Cells[J,I-1];
        if (Cells[0,I]<>'|->') and (Cells[0,I]<>'->|') then begin
          Cells[0,I]:=IntToStr(StrToInt(Cells[0,I])+1);
        end;
      end;
      for I:=0 to ColCount-1 do Cells[I,Ligne]:=Exemple[I];
      Cells[0,Ligne]:=Ptt_Text;
      Col:=2; Row:=Ligne;
    end;
  end;
end;

procedure TMultPageDlg.Supprimeruneligne1Click(Sender: TObject);
var
  Ligne, I, J, Delta : integer;
begin
  if MessageDlg('La ligne va dfinitivement tre supprime.',mtConfirmation,
                        [mbOk,mbCancel],0)=mrOk then with TableauVisee do begin
    if TableauVisee.Selection.Left=TableauVisee.Selection.Right then begin
      Ligne:=Souri_Ligne;
      if (Cells[0,Ligne]='|->') or (Cells[0,Ligne]='->|') then
        MessageDlg('Cette ligne n''est pas une vise.',mtWarning,[mbOk],0)
      else begin
        Modification:=true;
        for I:=Ligne to RowCount-2 do begin
          for J:=0 to ColCount-1 do Cells[J,I]:=Cells[J,I+1];
          if (Cells[0,I]<>'|->') and (Cells[0,I]<>'->|') then begin
            Cells[0,I]:=IntToStr(StrToInt(Cells[0,I])-1);
          end;
        end;
        RowCount:=RowCount-1;
        Row:=Ligne;
        Col:=2;
      end;
    end
    else begin //suppression de plusieurs lignes slectionnes
      try
        for I:=TableauVisee.Selection.Top to TableauVisee.Selection.Bottom do
         if (Cells[0,I]='|->') or (Cells[0,I]='->|') then begin
          MessageDlg('Vous ne pouvez pas supprimer en mme temps des vises et des carrefours.',mtWarning,[mbOk],0);
          Abort;
        end;
        Delta:=TableauVisee.Selection.Bottom-TableauVisee.Selection.Top;
        Modification:=true;
        Ligne:=TableauVisee.Selection.Top;
        for I:=Ligne to RowCount-2-Delta do begin
          for J:=0 to ColCount-1 do Cells[J,I]:=Cells[J,I+1+Delta];
          if (Cells[0,I]<>'|->') and (Cells[0,I]<>'->|') then begin
            Cells[0,I]:=IntToStr(StrToInt(Cells[0,I])-1-Delta);
          end;
        end;
        RowCount:=RowCount-1-Delta;
        Row:=Ligne;
        Col:=2;
      except
      end;
    end;
    TableauViseeClick(Sender);
  end;
end;

function TMultPageDlg.BaseFiche(Position : smallInt) : boolean;
begin
  BaseFiche:=(Position>=List_Noeud.Count*2) and not DernierExiste;
end;

procedure TMultPageDlg.Button3Click(Sender: TObject);
var
  Resultat, Position, I, Ligne : smallInt;
  Un_Noeud : TNoeud;
  T0, T1, T2 : string;
  Connerie, Echec : boolean;
begin
  Connerie:=false;
  Position:=0;
  for I:=2 to TableauVisee.Row do if (TableauVisee.Cells[0,I]='|->')
                       or (TableauVisee.Cells[0,I]='->|') then inc(Position);
  Ligne:=TableauVisee.Row;
  if BaseFiche(Position) then Point_Topo.Definit_Etat(Pt_Arrivee+Complique,Le_Massif,true)
                         else Point_Topo.Definit_Etat(Pt_Arrivee+Reduit,Le_Massif,true);
  Resultat:=Point_Topo.ShowModal;
  case Resultat of
    mrOk : begin
      Modification:=true;
      Un_Noeud:=TNoeud.Create;
      Point_Topo.Decharge(Un_Noeud.Precedent);
      if not Un_Noeud.Precedent.Terminus then begin
        T0:=Point_Topo.Nom.Text+'('+Point_Topo.Ind.Text+')';
      end
      else begin
        T0:='Terminus';
        T2:='';
      end;
      Echec:=false;
      Point_Topo.Definit_Etat(Pt_Depart+Reduit,Le_Massif,false);
      if Point_Topo.ShowModal=mrOk then begin
        Point_Topo.Decharge(Un_Noeud.Suivant);
        if not Un_Noeud.Suivant.Terminus then begin
          T1:=Point_Topo.Nom.Text+'('+Point_Topo.Ind.Text+')';
        end
        else begin
          T1:='Terminus';
          T2:='';
        end;
      end
      else Echec:=true;
      if not Echec then begin
        Informations.Charge(Un_Noeud.Info,1,1);
        if Informations.ShowModal=mrOk then begin
          Modification:=Modification or Informations.Modifie;
          Informations.decharge(Un_Noeud.Info,Un_Noeud.FDefor,Un_Noeud.Du_Topofil);
          Un_Noeud.Couleur:=clBlack;
          T2:=Informations.Info.Text;
        end
        else Echec:=true;
      end;
      if not Echec then begin
        Insere_Lgn(Ligne,'->|',T0,'');
        Insere_Lgn(Ligne+1,'|->',T1,T2);
        List_Noeud.Insert(Position div 2,Un_Noeud);
        TableauVisee.SetFocus;
        TableauVisee.Row:=Ligne+2;
        TableauVisee.Col:=2;
      end
      else Un_Noeud.Free;
    end;
    mrYes : begin
      Modification:=Modification or Point_Topo.Modifie;
      if MessageDlg('Toutes les valeurs en dessous de cette ligne vont tre perdues.',
              mtWarning,[mbOk,mbCancel],0)=mrOk then begin
        Dernier:=TPointTopo.Create;
        DernierExiste:=true;
        Point_Topo.Decharge(Dernier);
        if not Dernier.Terminus then begin
          T1:=Point_Topo.Nom.Text+'('+Point_Topo.Ind.Text+')';
        end
        else begin
          T1:='Terminus';
        end;
        Insere_Lgn(Ligne,'->|',T1,'');
        TableauVisee.RowCount:=Ligne+1;
        TableauVisee.Row:=Ligne-1;
        TableauVisee.SetFocus;
      end;
    end;
  end;
  if Connerie then begin
  end;
end;

procedure TMultPageDlg.Insere_Lgn(Position : SmallInt; Nature, T1, T2 : string);
var
  I, J : SmallInt;
begin
  TableauVisee.RowCount:=TableauVisee.RowCount+1;
  for I:=TableauVisee.RowCount-1 downto Position+1 do begin
    for J:=0 to TableauVisee.ColCount-1 do TableauVisee.Cells[J,I]:=TableauVisee.Cells[J,I-1];
  end;
  for J:=1 to TableauVisee.ColCount-1 do begin
    TableauVisee.Cells[J,Position]:='';
    if Le_Format.Visuel[J].Intitule=coCOMMENT then TableauVisee.Cells[J,Position]:=T2;
  end;
  TableauVisee.Cells[0,Position]:=Nature;
  TableauVisee.Cells[1,Position]:=T1;
end;

procedure TMultPageDlg.Insrerunpoint1Click(Sender: TObject);
begin
  if TableauVisee.Cells[0,Souri_Ligne]<>'|->' then begin
    TableauVisee.Row:=Souri_Ligne;
    Button3Click(Sender);
  end;
end;

procedure TMultPageDlg.Supprimerunpoint1Click(Sender: TObject);
var
  Position, I, J : integer;
  Un_Noeud : TNoeud;
  S : string;
  Echec, Connerie: boolean;
begin
  Connerie:=false;
  if ((TableauVisee.Cells[0,Souri_Ligne]='|->') or
     (TableauVisee.Cells[0,Souri_Ligne]='->|')) and
     (Souri_Ligne>1) and (Souri_Ligne<TableauVisee.RowCount-1) and
     (MessageDlg('Les deux points et les informations correspondantes vont tre supprimes',
     mtConfirmation,[mbOk,mbCancel],0)=mrOk) then begin
    Modification:=true;
    if TableauVisee.Cells[0,Souri_Ligne]='|->' then dec(Souri_Ligne);
    Position:=0;
    for I:=2 to Souri_Ligne do if TableauVisee.Cells[0,I]='->|' then inc(Position);
{fusionner ici, il peut y avoir cration de branches orphelines }
    Echec:=false;
    Un_Noeud:=List_Noeud[Position-1];
    if not Echec then begin
      List_Noeud.Delete(Position-1);
      List_Noeud.Pack;
      Un_Noeud.Free;
      S:=TableauVisee.Cells[0,Souri_Ligne-1];
      for J:=Souri_Ligne to TableauVisee.RowCount-3 do
        for I:=0 to TableauVisee.ColCount-1 do
          TableauVisee.Cells[I,J]:=TableauVisee.Cells[I,J+2];
      TableauVisee.RowCount:=TableauVisee.RowCount-2;
    end;
  end;
  if (Souri_Ligne=TableauVisee.RowCount-1) and DernierExiste and
    (MessageDlg('Supprimer le dernier point et continuer?',mtConfirmation,
     [mbOk,mbCancel],0)=mrOk) then begin
    Modification:=true;
    Dernier.Free; Dernier:=nil; DernierExiste:=false;
    TableauVisee.RowCount:=TableauVisee.RowCount-1;
    TableauVisee.Row:=TableauVisee.RowCount-1;
  end;
  if Connerie then begin
  end;
end;

procedure TMultPageDlg.PopupMenu1Popup(Sender: TObject);
begin
  InsrerUneLigne1.Enabled:=(Souri_Ligne>1) and (TableauVisee.Cells[0,Souri_Ligne]<>'|->');
  Supprimeruneligne1.Enabled:=(TableauVisee.Cells[0,Souri_Ligne]<>('->|')) and
                   (TableauVisee.Cells[0,Souri_Ligne]<>('|->'));
  Supprimerunpoint1.Enabled:=(Souri_Ligne>1) and not Supprimeruneligne1.Enabled;
  InsrerUnPoint1.Enabled:=InsrerUneLigne1.Enabled;
end;

procedure TMultPageDlg.ListeClick(Sender: TObject);
var
  F : textfile;
  S : string;
  I : integer;
begin
  if not FileExists(Form1.RepOption+'EXPLORAT.TXT') then
  try
    copyFile(PChar(Form1.Repertoire+'EXPLORAT.TXT'),PChar(Form1.RepOption+'EXPLORAT.TXT'),true);
  except
  end;
  AssignFile(F,Form1.RepOption+'EXPLORAT.TXT');
  Explorateur:=TExplorateur.Create(self);
  Explorateur.SrcList.Items.Clear;
  Explorateur.DstList.Items.Clear;
  Reset(F);
  while not Eof(F) do begin
    readln(F,S);
    Explorateur.SrcList.Items.Add(S);
  end;
  closeFile(F);
  if Explorateur.ShowModal=mrOk then begin
    for I:=0 to Explorateur.DstList.Items.Count-1 do begin
      S:=Explorateur.DstList.Items[I];
      Topographe.Lines.Add(S);
    end;
  end;
  Explorateur.Free;
end;

procedure TMultPageDlg.Sauvegarder(var F : TFileBufferStream);
var
  S : string;
  Chaine : TEco;
  I, J, Nombre, Verticale : smallInt;
  Un_Point : TNoeud;
begin
  Chaine:=Teco.Create;
  S:=Systeme.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  S:=Cavite.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  S:=Reseau.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  S:=Lieu.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  S:=Date.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  S:=Declinaison.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  S:=UniteDecli.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  Nombre:=Topographe.Lines.Count;
  F.write(Nombre,sizeOf(Nombre));
  for I:=0 to Nombre-1 do begin
    S:=Topographe.Lines[I];
    Chaine.Ecrit(S); Chaine.Sauve(F);
  end;
  S:=TPST.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  S:=Premiere.Text;
  Chaine.Ecrit(S); Chaine.Sauve(F);
  Nombre:=TableauVisee.ColCount;
  F.write(Nombre,sizeOf(Nombre));
  Verticale:=TableauVisee.RowCount;
  F.write(Verticale,sizeOf(Verticale));
  for I:=0 to Verticale-1 do
    for J:=0 to Nombre-1 do begin
      S:=TableauVisee.Cells[J,I];
      Chaine.Ecrit(S); Chaine.Sauve(F);
    end;
  if Ancienne then Nombre:=La_Fiche.Ordre else Nombre:=-1;
  F.write(Nombre,sizeOf(Nombre));
  Premier.Sauve(F);
  PremierInfo.Sauve(F);
  F.write(PremierDefo,sizeOf(PremierDefo));
  F.write(PremierTopofil,sizeOf(PremierTopofil));
  F.write(DernierExiste,sizeOf(DernierExiste));
  if DernierExiste then Dernier.Sauve(F);
  Nombre:=List_Noeud.Count;
  F.write(Nombre,sizeOf(Nombre));
  for I:=0 to Nombre-1 do begin
    Un_Point:=List_Noeud[I];
    Un_Point.Sauvegarder(F);
  end;
  Chaine.Free;
end;

procedure TMultPageDlg.Recuperer(var F : TFileBufferStream);
var
  S : string;
  Chaine : TEco;
  I, J, Nombre, Verticale : smallInt;
  Une_Fiche : TFiche;
  Un_Point : TNoeud;
begin
  Le_Format:=Form1.Preference;
  Formatage(Le_Format);

  Chaine:=TEco.Create;
  Chaine.Loade(F); Chaine.Lit(S);
  Systeme.Text:=S;
  Chaine.Loade(F); Chaine.Lit(S);
  Cavite.Text:=S;
  Chaine.Loade(F); Chaine.Lit(S);
  Reseau.Text:=S;
  Chaine.Loade(F); Chaine.Lit(S);
  Lieu.Text:=S;
  Chaine.Loade(F); Chaine.Lit(S);
  Date.Text:=S;
  Chaine.Loade(F); Chaine.Lit(S);
  Declinaison.Text:=S;
  Chaine.Loade(F); Chaine.Lit(S);
  UniteDecli.Text:=S;
  F.Read(Nombre,sizeOf(Nombre));
  for I:=0 to Nombre-1 do begin
    Chaine.Loade(F); Chaine.Lit(S);
    Topographe.Lines.Add(S);
  end;
  Chaine.Loade(F); Chaine.Lit(S);
  TPST.Text:=S;
  Chaine.Loade(F); Chaine.Lit(S);
  Premiere.Text:=S;
  F.Read(Nombre,sizeOf(Nombre));
  F.Read(Verticale,sizeOf(Verticale));
  for I:=0 to Verticale-1 do begin
    if I>=TableauVisee.RowCount then Ajouter_Ligne;
    for J:=0 to Nombre-1 do begin
      Chaine.Loade(F); Chaine.Lit(S);
      TableauVisee.Cells[J,I]:=S;
    end;
  end;
  F.Read(Nombre,sizeOf(Nombre));
  Le_Massif:=Form1.Massif;
  if Nombre=-1 then Ancienne:=false
  else begin
    Ancienne:=true;
    for I:=0 to Le_Massif.Liste_Fiche.Count-1 do begin
      Une_Fiche:=Le_Massif.Liste_Fiche[I];
      if Une_Fiche.Ordre=Nombre then La_Fiche:=Une_Fiche;
    end;
  end;
  Premier:=TPointTopo.Create;
  Premier.Loade(F);
  PremierInfo:=TEco.Create;
  PremierInfo.Loade(F);
  F.Read(PremierDefo,sizeOf(PremierDefo));
  F.Read(PremierTopofil,sizeOf(PremierTopofil));
  F.Read(DernierExiste,sizeOf(DernierExiste));
  if DernierExiste then begin
    Dernier:=TPointTopo.Create;
    Dernier.Loade(F);
    TableauVisee.RowCount:=Verticale;
  end;
  Nombre:=List_Noeud.Count;
  F.Read(Nombre,sizeOf(Nombre));
  for I:=0 to Nombre-1 do begin
    Un_Point:=TNoeud.Create;
    Un_Point.Recuperer(F);
    List_Noeud.Add(Un_Point);
  end;
  TableauVisee.Row:=2; TableauVisee.Col:=2;
  Chaine.Free;
  Modification:=true;
end;

procedure TMultPageDlg.Terminer1Click(Sender: TObject);
begin
  if not Modification then
  begin
    ModalResult:=mrOk;
    ToutVider;
  end
  else if Enregistrer then
  begin
    Nouvel_Aspect;
    Le_Massif.Sauvegarde:=false;
    ToutVider;
    if Form1.Automatique1.Checked then
    begin
      if Calcul_en_cours then Calcul_Arrete:=true;
      Form1.Depart_Calcul_Rapide.Enabled:=true;
    end;
    ModalResult:=mrOk;
    if Form1.Exploreur.WindowState=wsMaximized then
      Form1.Exploreur.Frais;
  end;
end;

procedure TMultPageDlg.Suivante1Click(Sender: TObject);
begin
  if Enregistrer then
  begin
    Nouvel_Aspect;
    if Modification then Le_Massif.sauvegarde:=false;
    Modification:=false;
    ViderPage1;
    TableauVisee.Row:=2; TableauVisee.Col:=2;
    Contenu(nil,Le_Massif,Le_Format,0);
    if Form1.Automatique1.Checked then
    begin
      if Calcul_en_cours then
        Calcul_Arrete:=true;
      Form1.Depart_Calcul_Rapide.Enabled:=true;
    end;
    TabSet.TabIndex:=0;
    TableauVisee.SetFocus;
    if Form1.Exploreur.WindowState=wsMaximized then
      Form1.Exploreur.Frais;
  end;
end;

procedure TMultPageDlg.Annuler1Click(Sender: TObject);
begin
  Close;
end;

procedure TMultPageDlg.Enregistrer1Click(Sender: TObject);
begin
  Form1.Enregistrer1Click(Self);
end;

procedure TMultPageDlg.Nouveau1Click(Sender: TObject);
var
  Resultat, Position, I, Ligne : smallInt;
  Un_Noeud : TNoeud;
  T0, T1, T2 : string;
  Connerie, Echec : boolean;
begin
  Connerie:=false;
  Position:=0;
  for I:=2 to TableauVisee.Row do if (TableauVisee.Cells[0,I]='|->')
                       or (TableauVisee.Cells[0,I]='->|') then inc(Position);
  Ligne:=TableauVisee.Row;
  if BaseFiche(Position) then Point_Topo.Definit_Etat(Pt_Arrivee+Complique,Le_Massif,true)
                         else Point_Topo.Definit_Etat(Pt_Arrivee+Reduit,Le_Massif,true);
  Resultat:=Point_Topo.ShowModal;
  case Resultat of
    mrOk : begin
      Modification:=true;
      Un_Noeud:=TNoeud.Create;
      Point_Topo.Decharge(Un_Noeud.Precedent);
      if not Un_Noeud.Precedent.Terminus then begin
        T0:=Point_Topo.Nom.Text+'('+Point_Topo.Ind.Text+')';
      end
      else begin
        T0:='Terminus';
        T2:='';
      end;
      Echec:=false;
      Point_Topo.Definit_Etat(Pt_Depart+Reduit,Le_Massif,false);
      if Point_Topo.ShowModal=mrOk then begin
        Point_Topo.Decharge(Un_Noeud.Suivant);
        if not Un_Noeud.Suivant.Terminus then begin
          T1:=Point_Topo.Nom.Text+'('+Point_Topo.Ind.Text+')';
        end
        else begin
          T1:='Terminus';
          T2:='';
        end;
      end
      else Echec:=true;
      if not Echec then begin
        Informations.Charge(Un_Noeud.Info,1,1);
        if Informations.ShowModal=mrOk then begin
          Modification:=Modification or Informations.Modifie;
          Informations.decharge(Un_Noeud.Info,Un_Noeud.FDefor,Un_Noeud.Du_Topofil);
          Un_Noeud.Couleur:=clBlack;
          T2:=Informations.Info.Text;
        end
        else Echec:=true;
      end;
      if not Echec then begin
        Insere_Lgn(Ligne,'->|',T0,'');
        Insere_Lgn(Ligne+1,'|->',T1,T2);
        List_Noeud.Insert(Position div 2,Un_Noeud);
        TableauVisee.SetFocus;
        TableauVisee.Row:=Ligne+2;
        TableauVisee.Col:=2;
      end
      else Un_Noeud.Free;
    end;
    mrYes : begin
      Modification:=Modification or Point_Topo.Modifie;
      if MessageDlg('Toutes les valeurs en dessous de cette ligne vont tre perdues.',
              mtWarning,[mbOk,mbCancel],0)=mrOk then begin
        Dernier:=TPointTopo.Create;
        DernierExiste:=true;
        Point_Topo.Decharge(Dernier);
        if not Dernier.Terminus then begin
          T1:=Point_Topo.Nom.Text+'('+Point_Topo.Ind.Text+')';
        end
        else begin
          T1:='Terminus';
        end;
        Insere_Lgn(Ligne,'->|',T1,'');
        TableauVisee.RowCount:=Ligne+1;
        TableauVisee.Row:=Ligne-1;
        TableauVisee.SetFocus;
      end;
    end;
  end;
  if Connerie then begin
  end;
end;

procedure TMultPageDlg.Modifier1Click(Sender: TObject);
begin
  if TableauVisee.Cells[0,TableauVisee.Row]='|->' then Editer_Depart
  else if TableauVisee.Cells[0,TableauVisee.Row]='->|' then Editer_Arrivee;
end;


procedure TMultPageDlg.Editer_Depart;
var
  S : string;
  Position, I : SmallInt;
begin
  with TableauVisee do begin
    Position:=0;
    for I:=2 to TableauVisee.Row do if TableauVisee.Cells[0,I]='->|' then inc(Position);
    Point_Topo.Definit_Etat(Pt_Depart+Reduit,Le_Massif,true);
    if Position=0 then begin
      Point_Topo.Charger(Premier);
      if Point_Topo.ShowModal=mrOk then begin
        Modification:=Modification or Point_Topo.Modifie;
        Point_Topo.Decharge(Premier);
        if Premier.Terminus then begin
          TableauVisee.Cells[1,1]:='Terminus';
        end
        else begin
          Premier.Nom.Lit(S);
          TableauVisee.Cells[1,1]:=S+'('+IntTostr(Premier.Indice)+')';
        end;
      end;
    end
    else with TNoeud(List_Noeud[Position-1]) do begin
      Point_Topo.Charger(Suivant);
      if Point_Topo.ShowModal=mrOk then begin
        Modification:=Modification or Point_Topo.Modifie;
        Point_Topo.Decharge(Suivant);
        if Suivant.Terminus then begin
          TableauVisee.Cells[1,Row]:='Terminus';
        end
        else begin
          Suivant.Nom.Lit(S);
          TableauVisee.Cells[1,Row]:=S+'('+IntTostr(Suivant.Indice)+')';
        end;
      end;
    end;
  end;
end;

procedure TMultPageDlg.Editer_Arrivee;
var
  S : string;
  Position, I : SmallInt;
begin
  with TableauVisee do begin
    Position:=0;
    for I:=2 to TableauVisee.Row do if TableauVisee.Cells[0,I]='->|' then inc(Position);
    Point_Topo.Definit_Etat(Pt_Arrivee+Reduit,Le_Massif,true);
    if Position>List_Noeud.Count then begin
      Point_Topo.Charger(Dernier);
      if Point_Topo.ShowModal=mrOk then begin
        Modification:=Modification or Point_Topo.Modifie;
        Point_Topo.Decharge(Dernier);
        if Dernier.Terminus then begin
          TableauVisee.Cells[1,Row]:='Terminus';
        end
        else begin
          Dernier.Nom.Lit(S);
          TableauVisee.Cells[1,Row]:=S+'('+IntTostr(Dernier.Indice)+')';
        end;
      end;
    end
    else with TNoeud(List_Noeud[Position-1]) do begin
      Point_Topo.Charger(Precedent);
      if Point_Topo.ShowModal=mrOk then begin
        Modification:=Modification or Point_Topo.Modifie;
        Point_Topo.Decharge(Precedent);
        if Precedent.Terminus then begin
          TableauVisee.Cells[1,Row]:='Terminus';
        end
        else begin
          Precedent.Nom.Lit(S);
          TableauVisee.Cells[1,Row]:=S+'('+IntTostr(Precedent.Indice)+')';
        end;
      end;
    end;
  end;
end;

procedure TMultPageDlg.Editer_Commentaire;
var
  Position, I : integer;
begin
  with TableauVisee do begin
    Position:=0;
    for I:=2 to TableauVisee.Row do if TableauVisee.Cells[0,I]='->|' then inc(Position);
    if Row=1 then begin
      Informations.Charge(PremierInfo,PremierDefo,PremierTopofil);
      if Informations.ShowModal=mrOk then begin
        Modification:=Modification or Informations.Modifie;
        Informations.Decharge(PremierInfo,PremierDefo,PremierTopofil);
        for I:=1 to ColCount-1 do
           if Le_Format.Visuel[I].Intitule=coCOMMENT then Cells[I,1]:=Informations.Info.Text;
      end;
    end
    else with TNoeud(List_Noeud[Position-1]) do begin
      Informations.Charge(Info,Defor,Du_Topofil);
      if Informations.ShowModal=mrOk then begin
        Modification:=Modification or Informations.Modifie;
        Informations.Decharge(Info,FDefor,Du_Topofil);
        for I:=1 to ColCount-1 do
           if Le_Format.Visuel[I].Intitule=coCOMMENT then Cells[I,Row]:=Informations.Info.Text;
      end;
    end;
  end;
end;

procedure TMultPageDlg.Commentaire1Click(Sender: TObject);
begin
  Editer_Commentaire;
end;

procedure TMultPageDlg.Supprimer3Click(Sender: TObject);
begin
  Souri_Ligne:=TableauVisee.Row;
  Supprimerunpoint1Click(Sender);
end;

procedure TMultPageDlg.Point1Click(Sender: TObject);
begin
  if TableauVisee.Cells[0,TableauVisee.Row]='|->' then begin
    Modifier1.Enabled:=true;
    Commentaire1.Enabled:=true;
    Supprimer3.Enabled:=true;
    Nouveau1.Enabled:=false;
  end
  else if TableauVisee.Cells[0,TableauVisee.Row]='->|' then begin
    Modifier1.Enabled:=true;
    Commentaire1.Enabled:=false;
    Supprimer3.Enabled:=true;
    Nouveau1.Enabled:=false;
  end
  else begin
    Modifier1.Enabled:=false;
    Commentaire1.Enabled:=false;
    Supprimer3.Enabled:=false;
    Nouveau1.Enabled:=true;
  end;
end;

procedure TMultPageDlg.Importerduntableur1Click(Sender: TObject);
begin
  ImporterClick(Sender);
end;

procedure TMultPageDlg.Continuerenbas1Click(Sender: TObject);
var
  Ligne : integer;
  Un_Noeud : TNoeud;
  T1, T2 : string;
begin
  Ligne:=TableauVisee.RowCount-1;
  Point_Topo.Definit_Etat(Pt_Depart+Reduit,Le_Massif,true);
  if Point_Topo.ShowModal=mrOk then begin
    Modification:=true;
    DernierExiste:=false;
    with TableauVisee do begin
      Col:=1; Row:=RowCount-1;
      TableauViseeclick(sender);
    end;  
    Un_Noeud:=TNoeud.Create;
    Un_Noeud.Precedent.Terminus:=Dernier.Terminus;
    Un_Noeud.Precedent.Indice:=Dernier.Indice;
    Dernier.Nom.Lit(T1);
    Un_Noeud.Precedent.Nom.Ecrit(T1);
    Dernier.Free; Dernier:=nil;
    Point_Topo.Decharge(Un_Noeud.Suivant);
    if not Un_Noeud.Suivant.Terminus then begin
      T1:=Point_Topo.Nom.Text+'('+Point_Topo.Ind.Text+')';
    end
    else begin
      T1:='Terminus';
      T2:='';
    end;
    Informations.Charge(Un_Noeud.Info,1,1);
    if Informations.ShowModal=mrOk then begin
      Modification:=Modification or Informations.Modifie;
      Informations.decharge(Un_Noeud.Info,Un_Noeud.FDefor,Un_Noeud.Du_Topofil);
      Un_Noeud.Couleur:=clBlack;
      T2:=Informations.Info.Text;
    end
    else begin
      T2:='';
      Un_Noeud.Info.Ecrit(T2);
      Un_Noeud.Defor:=1;
      Un_Noeud.Du_Topofil:=1;
    end;
    Insere_Lgn(Ligne+1,'|->',T1,T2);
    List_Noeud.Add(Un_Noeud);
    TableauVisee.SetFocus;
    TableauVisee.Row:=Ligne+2;
    TableauVisee.Col:=2;
  end;
end;

procedure TMultPageDlg.Tableau1Click(Sender: TObject);
begin
  Continuerenbas1.Enabled:=DernierExiste;
  if (TableauVisee.Cells[0,TableauVisee.Row]='|->') or
  (TableauVisee.Cells[0,TableauVisee.Row]='->|') then begin
    InsreruneVise1.Enabled:=false;
    SupprimeruneVise1.Enabled:=false;
  end
  else begin
    InsreruneVise1.Enabled:=true;
    SupprimeruneVise1.Enabled:=true;
  end;
end;

procedure TMultPageDlg.Insrerunevise1Click(Sender: TObject);
begin
  Souri_Ligne:=TableauVisee.Row;
  Insreruneligne1Click(Sender);
end;

procedure TMultPageDlg.Supprimerunevise1Click(Sender: TObject);
begin
  Souri_Ligne:=TableauVisee.Row;
  Supprimeruneligne1Click(Sender);
end;

procedure TMultPageDlg.Coller1Click(Sender: TObject);
begin
  SendKeys('^V');
end;

procedure TMultPageDlg.Copier1Click(Sender: TObject);
begin
  SendKeys('^C');
end;

procedure TMultPageDlg.Couper1Click(Sender: TObject);
begin
  SendKeys('^X');
end;

procedure TMultPageDlg.Supprimer2Click(Sender: TObject);
begin
  SimulateKeyPresses(vk_Delete);
end;

procedure TMultPageDlg.Toutcopier1Click(Sender: TObject);
var
  P : PChar;
  I, J, K, Position, Compteur : integer;
  S : string;
  Un_Noeud : TNoeud;
begin
  GetMem(P,32000);
  Position:=0;
  Compteur:=0;
  for I:=0 to TableauVisee.RowCount-1 do begin
    for J:=1 to TableauVisee.ColCount-1 do begin
      if (J=2) and (TableauVisee.Cells[0,I]='|->') then begin
        if Compteur=0 then S:=FloatToStrF(PremierTopofil,ffGeneral,4,3)
        else begin
          Un_Noeud:=List_Noeud[Compteur-1];
          S:=FloatToStrF(Un_Noeud.Du_Topofil,ffGeneral,4,3);
        end;
        inc(Compteur);
      end
      else S:=TableauVisee.Cells[J,I];
      for K:=1 to length(S) do P[Position+K-1]:=S[K];
      P[Position+length(S)]:=chr(9);
      inc(Position,length(S)+1);
    end;
    P[Position-1]:=chr(13);
    P[Position]:=chr(10);
    inc(Position);
  end;
  P[Position]:=chr(0);
  ClipBoard.SetTextBuf(P);
  FreeMem(P,32000);
end;

procedure TMultPageDlg.DeclinaisonKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) and (Key<>'.')
    and (Key<>'-') then Key := #0;
end;

procedure TMultPageDlg.TableauViseeClick(Sender: TObject);
var
  J, Decalage, Nature : SmallInt;
  Rectangle : TRect;
begin
  with TableauVisee do if (Row<>0) and (Col<>0) then begin
    Souri_Ligne:=Row;
    if not DernierExiste then begin
      if (Selection.Top>=RowCount-1) and (RowCount<1000) then begin
        Decalage:=0;
        for J:=0 to RowCount-1 do if (Cells[0,J]='->|') or (Cells[0,J]='|->') then inc(Decalage);
        RowCount:=RowCount+1;
        for J:=0 to ColCount-1 do Cells[J,RowCount-1]:=Exemple[J];
        Cells[0,RowCount-1]:=IntTostr(RowCount-1-Decalage);
      end;
    end;
    if (Cells[0,Selection.Top]<>('->|')) and (Cells[0,Selection.Top]<>('|->'))
     and (Col>=2) then begin
      Options:=Options+[goEditing,goAlwaysShowEditor];

      Nature:=Le_Format.Visuel[TableauVisee.Col].Intitule;
      if Nature>=coUnite then begin
        Unite.Visible:=true;
        Rectangle:=CellRect(Selection.Left, Selection.Top);
        Unite.Left:=Rectangle.Left+TableauVisee.Left; Unite.Top:=Rectangle.Top+TableauVisee.Top;
        Unite.Text:=Cells[Selection.Left, Selection.Top];
        if ColWidths[Col]>47 then
        Unite.Width:=ColWidths[Col]
        else Unite.Width:=47;
        Unite.Height:=defaultRowHeight;
        if (Nature=coULONG) or (Nature=coULARG) or (Nature=coUHAUT) then with Unite.Items do begin
          Clear; Add(tuDistance[m]); Add(tuDistance[cm]);
        end;
        if Nature=coUAZ then with Unite.Items do begin
          Clear; Add(tuAngle[deg]); Add(tuAngle[gr]); Add(tuAngle[ndeg]); Add(tuAngle[ngr]);
        end;
        if Nature=coUPENTE then with Unite.Items do begin
          Clear; Add(tuAngle[deg]); Add(tuAngle[gr]); Add(tuAngle[ndeg]); Add(tuAngle[ngr]);
          Add(tuAngle[mp]); Add(tuAngle[cmp]); Add(tuAngle[nmp]); Add(tuAngle[ncmp]);
          Add(tuAngle[vdeg]); Add(tuAngle[nvdeg]);
        end;
        Unite.SetFocus;
      end;
    end
    else begin
      Options:=Options-[goEditing,goAlwaysShowEditor];
      EditorMode:=false;
    end;
  end;
end;

procedure TMultPageDlg.TableauViseeDblClick(Sender: TObject);
begin
  with TableauVisee do begin
    if Souri_Ligne=0 then Ajuste(TableauVisee,Souri_Colonne);
    if (Cells[0,Row]='->|') or (TableauVisee.Cells[0,Row]='|->') then begin
      if Cells[0,Row]='|->' then begin
        if Col<2 then begin
          Editer_Depart;
        end
        else Editer_Commentaire;
      end
      else if Cells[0,Row]='->|' then begin
        Editer_Arrivee;
      end;
    end
    else begin
      if (Le_Format.Visuel[Col].Intitule and coDef)<>0 then begin
        if (Cells[Col,Row]='N') or (Cells[Col,Row]='n')
          then Cells[Col,Row]:='O'
          else Cells[Col,Row]:='N';
      end;
      if Le_Format.Visuel[Col].Intitule=coPOINT then Button3Click(Sender);
    end;
  end;
end;

procedure TMultPageDlg.Formatage(Affichage : TPreference_Ecran);
var
  I, J : SmallInt;
begin
  with TableauVisee do begin
    ColCount:=Affichage.Nb_Colonne+1;
    RowCount:=11;
    Exemple[0]:='';
    for J:=1 to Affichage.Nb_Colonne do Exemple[J]:=Affichage.Visuel[J].Remplissage;
    for I:=1 to RowCount-1 do  for J:=1 to Affichage.Nb_Colonne do begin
      Cells[J,I]:=Exemple[J];
    end;
    ColWidths[0]:=30;
    for I:=1 to ColCount-1 do begin
      ColWidths[I]:=Affichage.Visuel[I].Pixel;
      Cells[I,0]:=Affichage.Visuel[I].En_Tete;
    end;
    for I:=1 to RowCount-1 do Cells[0,I]:=IntToStr(I);
    Cells[0,0]:='';
  end;
end;

procedure TMultPageDlg.Ajouter_Ligne;
var
  J : SmallInt;
begin
  with TableauVisee do begin
    RowCount:=RowCount+1;
    for J:=0 to ColCount-1 do Cells[J,RowCount-1]:=Exemple[J];
    Cells[0,RowCount-1]:=IntToStr(RowCount-1);
  end;
end;


procedure TMultPageDlg.TableauViseeMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  TableauVisee.MouseToCell(X,Y,Souri_Colonne, Souri_Ligne);
  if Souri_Colonne=0 then begin
    TableauVisee.Options:=TableauVisee.Options + [goRangeSelect];
    Debut:=Souri_Ligne;
    Selection_en_cours:=true;
  end;
end;

procedure TMultPageDlg.TableauViseeMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  Rect : TGridRect;
begin
  if ssLeft in Shift then TableauVisee.MouseToCell(X,Y,Souri_Colonne, Souri_Ligne);
  if Selection_en_cours then begin
    Rect.Top:=Debut;
    Rect.Bottom:=Souri_Ligne;
    Rect.Left:=0;
    Rect.Right:=TableauVisee.ColCount-1;
    TableauVisee.Selection:=Rect;
  end;
end;

procedure TMultPageDlg.TableauViseeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Selection_En_Cours:=false;
  TableauVisee.Options:=TableauVisee.Options - [goRangeSelect];
end;

procedure TMultPageDlg.TableauViseeKeyPress(Sender: TObject;
  var Key: Char);
var
  Colonne_Courante : longint;
  Nature : integer;
begin
  if Key=#13 then begin
    Colonne_Courante:=TableauVisee.Col;
    repeat
      inc(Colonne_Courante);
      if Colonne_Courante>Le_Format.Nb_Colonne then begin
        TableauVisee.Row:=TableauVisee.Row+1;
        Colonne_Courante:=2;
      end;
      Nature:=Le_Format.Visuel[Colonne_Courante].Intitule;
    until ((Nature<coUnite) and (Nature<>coSCHEMA) and (Nature<>coDEFCOR) and
       (Nature<>coCORH) and (Nature<>coDEFDLT) and (Nature<>coCORDLT));
    TableauVisee.Col:=Colonne_Courante;
  end;
end;

procedure TMultPageDlg.UniteExit(Sender: TObject);
begin
  Unite.Visible:=false;
  with TableauVisee do Cells[Col,Row]:=Unite.Text;
  TableauVisee.SetFocus;
end;

procedure TMultPageDlg.UniteKeyPress(Sender: TObject; var Key: Char);
var
  Colonne_Courante : longint;
begin
  if Key=#13 then begin
    UniteExit(sender);
    key:=#0;
    Colonne_Courante:=TableauVisee.Col;
    inc(Colonne_Courante);
    if Colonne_Courante>Le_Format.Nb_Colonne then begin
      TableauVisee.Row:=TableauVisee.Row+1;
      Colonne_Courante:=2;
    end;
    TableauVisee.Col:=Colonne_Courante;
  end;
end;

procedure TMultPageDlg.UniteKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Colonne_Courante : longint;
begin
  if (Key=37) or (Key=39) then begin
    UniteExit(sender);
    Colonne_Courante:=TableauVisee.Col;
    if Key=39 then inc(Colonne_Courante) else dec(Colonne_Courante);
    key:=0;
    if Colonne_Courante>Le_Format.Nb_Colonne then begin
      TableauVisee.Row:=TableauVisee.Row+1;
      Colonne_Courante:=2;
    end;
    TableauVisee.Col:=Colonne_Courante;
  end;
end;

procedure TMultPageDlg.DateChange(Sender: TObject);
begin
  Modification:=true;
end;

procedure TMultPageDlg.TableauViseeSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  if (ACol>1) {and (Value<>TableauVisee.Cells[ARow,ACol])} then Modification:=true;
end;

end.

