{$N-}
unit Correcti;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Dialogs, SysUtils;

type
  TCorrection = class(TForm)
    Bevel1: TBevel;
    Edit1: TEdit;
    LaSelection: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    Mesure : byte;
    Portee : boolean;
  end;

var
  Correction: TCorrection;

implementation

uses Fichetpo;

{$R *.DFM}

procedure TCorrection.FormActivate(Sender: TObject);
begin
  if Portee then begin
    LaSelection.Checked:=false;
    LaSelection.Enabled:=false;
  end
  else begin
    LaSelection.Checked:=true;
    LaSelection.Enabled:=true;
  end;
  Canvas.Brush.Color:=clBtnFace;
  Canvas.TextOut(133,16,'Ajouter ');
  case Mesure of
    1 : Canvas.TextOut(117,40,'la longueur');
    2 : Canvas.TextOut(126,40,'l'' azimut');
    3 : Canvas.TextOut(130,40,'la pente');
  end;
end;

procedure TCorrection.OKBtnClick(Sender: TObject);
var
  Valeur : reel;
begin
  try
    Valeur:=StrToFloat(Edit1.Text);
  except
    ModalResult:=mrNone;
    MessageDlg('Valeur incorrecte'+#13+'exemple'+' 2.53',mtWarning,[mbOk],0);
    Edit1.SetFocus;
  end;
  Portee:=not LaSelection.Checked;
end;

procedure TCorrection.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) and (Key<>'.') and (Key<>'-')
      then Key := #0;
end;

end.
