{$N-}
unit Recherch;

interface

uses Classes, Fichetpo, CadreRec, Simple, Multiple, Controls;

function Recherche_Simple(var Origine : TList;var Un_Massif : TMassif;
      var Resultat : TFiche; var Position : integer; Un_Point, S1, S2, S3, S4 : string) : boolean;
function Recherche_Multiple(var Origine : TList;var Resultat : TList) : boolean;

implementation

function Recherche_Simple(var Origine : TList;var Un_Massif : TMassif;
              var Resultat : TFiche;var Position : integer; Un_Point, S1, S2, S3, S4 : string) : boolean;
var
  Echec : boolean;
  Intermediaire : TList;
  I : integer;
begin
  Echec:=false;
  Intermediaire:=TList.Create;
  BaseRecherche.Initialise(Origine,Intermediaire,Un_Point,S1,S2,S3,S4);
  if BaseRecherche.ShowModal<>mrCancel then begin
    case Position of
      -2 : RechSimp.Preparation(RGalerie,Intermediaire,Un_Massif,BaseRecherche.Point_Propose);
      -1 : RechSimp.Preparation(RFiche,Intermediaire,Un_Massif,BaseRecherche.Point_Propose);
      else RechSimp.Preparation(RVisee,Intermediaire,Un_Massif,BaseRecherche.Point_Propose);
    end;
    if RechSimp.ShowModal=mrOk then begin
      I:=RechSimp.La_Quelle;
      Position:=RechSimp.Quel_Lieu;
      Resultat:=Intermediaire[I];
    end
    else Echec:=true;
  end
  else Echec:=true;
  Recherche_Simple:=not Echec;
end;

function Recherche_Multiple(var Origine : TList;var Resultat : TList) : boolean;
var
  Echec : boolean;
  Intermediaire : TList;
  I : SmallInt;
begin
  Echec:=false;
  Intermediaire:=TList.Create;
  BaseRecherche.Initialise(Origine,Intermediaire,'','','','','');
  if BaseRecherche.ShowModal<>mrCancel then begin
    RechMulti.Preparation(Intermediaire);
    if RechMulti.ShowModal=mrOk then begin
      Resultat.Clear;
      for I:=0 to RechMulti.DstList.Items.Count-1 do Resultat.Add(RechMulti.DstList.Items.Objects[I]);
    end
    else Echec:=true;
  end
  else Echec:=true;
  Recherche_Multiple:=not Echec;
end;


end.
