{$N-}
unit Referen;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Grids, Dialogs,UAjuste, SysUtils;

type
  TReference = class(TForm)
    StringGrid1: TStringGrid;
    Supprimer: TButton;
    Button1: TButton;
    Button2: TButton;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure SupprimerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Ligne, Colonne : integer;
  end;

var
  Reference: TReference;

implementation

uses Fichetpo;

{$R *.DFM}

procedure TReference.FormActivate(Sender: TObject);
var
  I : SmallInt;
begin
  with stringGrid1 do begin
    Row:=1; Col:=1;
    Cells[1,0]:='Nom';
    Cells[2,0]:='Indice';
    Cells[3,0]:='X /km';
    Cells[4,0]:='Y /km';
    Cells[5,0]:='Z /m';
    for I:=1 to RowCount-1 do Cells[0,I]:=IntToStr(I);
  end;
end;

procedure TReference.OKBtnClick(Sender: TObject);
var
  I, J : integer;
  Ptt_Reel : reel;
begin
  with StringGrid1 do try
    for I:=1 to RowCount do begin
      if Cells[1,I]<>'' then begin
        Row:=I;
        Col:=2;
        if StrToInt(Cells[2,I])<=0 then Abort;
        for J:=3 to 5 do begin
          Col:=J;
          Ptt_Reel:=StrToFloat(Cells[J,I]);
        end;
      end;
    end;
  except
    ModalResult:=mrNone;
    MessageDlg('La valeur n''est pas correcte',mtWarning,[mbOk],0);
    SetFocus;
  end;
end;


procedure TReference.StringGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  with StringGrid1 do begin
    if key=chr(13) then begin
      if Col<5 then Col:=Col+1
               else begin
        Col:=1;
        Row:=Row+1;
      end;
    end;
    if Row+2>=RowCount then begin
      Cells[0,RowCount]:=IntTostr(RowCount);
      RowCount:=RowCount+1;
    end;
  end;
end;

procedure TReference.SupprimerClick(Sender: TObject);
var
  I, J : integer;
begin
  for I:=StringGrid1.Row+1 to StringGrid1.RowCount-1 do begin
    for J:=1 to 5 do StringGrid1.Cells[J,I-1]:=StringGrid1.Cells[J,I];
  end;
  for J:=1 to 5 do StringGrid1.Cells[J,StringGrid1.RowCount-1]:='';
end;

procedure TReference.FormCreate(Sender: TObject);
begin
  PixelsPerInch:=Screen.PixelsPerInch;
end;

procedure TReference.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  StringGrid1.MouseToCell(X,Y,Colonne, Ligne);
end;

procedure TReference.StringGrid1DblClick(Sender: TObject);
begin
  if Ligne=0 then Ajuste(StringGrid1,Colonne);
end;

procedure TReference.StringGrid1Click(Sender: TObject);
begin
  with StringGrid1 do begin
    if Row+2>=RowCount then begin
      Cells[0,RowCount]:=IntTostr(RowCount);
      RowCount:=RowCount+1;
    end;
  end;
end;

end.
